*
* $Id: book_mater.F,v 1.5 1996/05/10 13:08:43 zfiles Exp $
*
* $Log: book_mater.F,v $
* Revision 1.5  1996/05/10 13:08:43  zfiles
* Fixup and document magic nunmber in straggling term.
*
* Revision 1.4  1996/04/08 14:38:38  zfiles
* Test for error return form rad_length.F
*
* Revision 1.3  1996/03/12 14:19:52  zfiles
* Updates from Anders Ryd
*
* Revision 1.2  1995/08/29  13:28:18  zfiles
* Complete new set from Rob/Anders
*
*
C
C     Code created by 
C
C     Robert Kutschke : kutschke@lns598.lns.cornell.edu
C     Anders Ryd      : ryd@charm.physics.ucsb.edu
C
C     Created : Sept 1994 -- June 1995
C     Title   : book_mater
C     Purpose : To find the omount of material along a straight
C               line and calculate energy loss and multiple scattering
C     
C
C     Modifications:
C       March  11-96  Ryd:
C                     Added escape from the routine if error is
C                     set after return from get_vol_num
C       May    10-96  Kutschke
C                     Restore straggling fudge factor to its best
C                     guess ( was increased by a factor or 2 for 
C                     debuggind and then never restored ).
C

      subroutine book_mater(eta_fr,x_fr,y_fr,z_fr,
     +       eta_to,x_to,y_to,z_to,p,e,de,
     +       v2phi,v2t,v2k,vkt,ddk)

      implicit none

      real eta_fr(5),eta_to(5),x_fr,y_fr,z_fr,e,p,v2k,vkt
      real x_to,y_to,z_to,de,d2phi,dk,v2phi,v2t,ddk,dde
      real c1,tsq

#include "klmn/klmnseq/mater_n.inc" 
#include "klmn/klmnseq/cleofitcom.inc"
#include "klmn/klmnseq/klmntrk.inc"
#include "klmn/klmnseq/klmnctrl.inc"
#include "klmn/klmnseq/klmn_par.inc"
#include "klmn/klmnseq/klmnerror.inc"


      real x1(3),x2(3),s_list(max_list_n),x_dum(3),l_list(max_list_n)

      integer nentry,wafer_list(max_list_n),cham_in,cham_out
      integer in_out_list(max_list_n),i,j,get_vol_num

      tsq=1.0+eta_fr(4)**2

      if (klmnctrl_buildmater) then

        if (nmater_n.eq.0) then
          x1(1)=-eta_fr(3)*sin(eta_fr(2))+x_fr  
          x1(2)=eta_fr(3)*cos(eta_fr(2))+y_fr
          x1(3)=eta_fr(5)+z_fr
        else
          x1(1)=x2_mater_n(1,nmater_n)
          x1(2)=x2_mater_n(2,nmater_n)
          x1(3)=x2_mater_n(3,nmater_n)
        endif

        x2(1)=-eta_to(3)*sin(eta_to(2))+x_to 
        x2(2)=eta_to(3)*cos(eta_to(2))+y_to
        x2(3)=eta_to(5)+z_to

        if (nmater_n.eq.0) then
          cham_in=get_vol_num(x1)
          if (klmnerror_error(klmnctrl_part)) goto 999
          call rad_length(x1,x2,cham_in,cham_out,
     +              l_list,s_list,wafer_list,nentry)
          if (klmnerror_error(klmnctrl_part)) goto 999
        else
          call rad_length(x1,x2,last_vol(nmater_n),
     +            cham_out,l_list,s_list,wafer_list,nentry)
          if (klmnerror_error(klmnctrl_part)) goto 999
        endif


        call dedx_line(nmater_n,p,e,de,d2phi)

c       moved desum up here so that it is only build once!

       if ( .not. klmnctrl_noeloss )  desum = desum + de

       else

        call dedx_line(imater_n,p,e,de,d2phi)
        imater_n=imater_n+klmnctrl_in

       endif


C      check if outward track stops

       if (abs(de).gt.1.0*abs(e-klmnctrl_mass) .and. 
     +    klmnctrl_in .eq. -1) then

          de=0.0

       endif


       if ( klmnctrl_noms    ) d2phi = 0.
       if ( klmnctrl_noeloss ) de    = 0.



       v2phi=tsq*d2phi

       v2t=tsq*v2phi

       c1=eta_fr(1)*eta_fr(4)/tsq

       vkt=v2t*c1

       v2k=vkt*c1

C      energy loss straggling, simple minded 
C
C      The magic number gives the about the right answer for a 5GeV 
C      electron traversing 1m of propane ( STP ), for which the
C      energy loss is about 3keV/cm.

       if (de.gt.0.0) then
         dde=(0.001)**2*de
       else
         dde=0.0
       endif

       if ( klmnctrl_nostraggle ) dde = 0.

       ddk=dde*(e*eta_fr(1)/p**2)**2

999    continue

       return

       end











