*
* $Id: check_var.F,v 1.2 1995/08/29 13:28:24 zfiles Exp $
*
* $Log: check_var.F,v $
* Revision 1.2  1995/08/29 13:28:24  zfiles
* Complete new set from Rob/Anders
*
*
C
C     Code created by 
C
C     Robert Kutschke : kutschke@lns598.lns.cornell.edu
C     Anders Ryd      : ryd@charm.physics.ucsb.edu
C
C     Created : Sept 1994 -- June 1995
C     Title   : check_var
C     Purpose : To check is a variance matrix is good or bad.
C               I do not now of a proof that this test is
C               exhaustive. But I'm very convinced that
C               it is actually correct and sufficient.
C                                            Anders
C               Implementation is for 5x5 matrix but 
C               generalizations are trivial.
C     
C
C     Modifications:
C
C
C
       subroutine check_var(v,txt)

       implicit none

       real*8 v(5,5)
       real*8 d(5,5),dsq
       integer i,j,n
       character*(*) txt
      

       do 10,i=1,5
         do 20,j=1,i-1
           d(j,i)=v(i,j)           
           do 25,n=1,j-1
              d(j,i)=d(j,i)-d(n,i)*d(n,j)
25         continue
           d(j,i)=d(j,i)/d(j,j)
20       continue
         dsq=v(i,i)
         do 15,n=1,i-1
           dsq=dsq-d(n,i)**2
15       continue
         if (dsq.le.0.0D0) then
           print *,'Error in variance matrix:',txt
           print *,v(1,1),v(1,2),v(1,3),v(1,4),v(1,5)
           print *,v(2,1),v(2,2),v(2,3),v(2,4),v(2,5)
           print *,v(3,1),v(3,2),v(3,3),v(3,4),v(3,5)
           print *,v(4,1),v(4,2),v(4,3),v(4,4),v(4,5)
           print *,v(5,1),v(5,2),v(5,3),v(5,4),v(5,5)
           goto 999
         endif
         d(i,i)=sqrt(dsq)
10       continue

999    continue

       return

       end
