*
* $Id: cleostereoder.F,v 1.2 1995/08/29 13:28:27 zfiles Exp $
*
* $Log: cleostereoder.F,v $
* Revision 1.2  1995/08/29 13:28:27  zfiles
* Complete new set from Rob/Anders
*
*
C
C     Code created by 
C
C     Robert Kutschke : kutschke@lns598.lns.cornell.edu
C     Anders Ryd      : ryd@charm.physics.ucsb.edu
C
C     Created : Sept 1994 -- June 1995
C     Title   : cleostereoder
C     Purpose : this routine calculates the derivatives with respect to
C               the track parameters for the distance of closest aproach
C               of the track to a stereo-wire
C     
C
C     Modifications:
C
C
C


      subroutine cleostereoder(k,d0,phi,z,t,i,der,dw)
 
      implicit none

#include "klmn/klmnseq/cleofitcom.inc"
#include "klmn/klmnseq/mater_stop.inc"

      integer i
      real k,d0,phi,z,t,psi,der(5)
      real dw,stereo_dist

      real sphi,cphi,q,rho,sqpsi,cqpsi
      real xt,yt
      real dxtdk,dytdk,dztdk,dxtdd0,dytdd0
      real dxtdphi,dytdphi,dztdt,inv2k,inv2k2
      real v1xv2(3)


C     first have to find point of closest approach to the
C     wire
      dw=stereo_dist(k,d0,phi,z,t,
     +      x_0(i)-x(i),y_0(i)-y(i),cx(i),cy(i),psi,v1xv2)

      sphi=sin(phi)
      cphi=cos(phi)

      q=sign(1.0,k)

      inv2k=0.5/k
      inv2k2=inv2k/k

      rho=abs(inv2k)

      sqpsi=sin(phi+q*psi)
      cqpsi=cos(phi+q*psi)

      xt=-d0*sphi+(sqpsi-sphi)*inv2k
      yt=d0*cphi+(cphi-cqpsi)*inv2k

      dxtdk=-(sqpsi-sphi)*inv2k2
      dytdk=-(cphi-cqpsi)*inv2k2
      dztdk=-t*q*psi*inv2k2

      dxtdd0=-sphi
      dytdd0=cphi
    
      dxtdphi=-yt
      dytdphi=xt

      dztdt=rho*psi
      
      der(1)=v1xv2(1)*dxtdk+v1xv2(2)*dytdk+v1xv2(3)*dztdk
      der(2)=v1xv2(1)*dxtdphi+v1xv2(2)*dytdphi
      der(3)=v1xv2(1)*dxtdd0+v1xv2(2)*dytdd0
      der(4)=v1xv2(3)*dztdt
      der(5)=v1xv2(3)
      
      return

      end












