*
* $Id: cyl_int.F,v 1.2 1995/08/29 13:28:29 zfiles Exp $
*
* $Log: cyl_int.F,v $
* Revision 1.2  1995/08/29 13:28:29  zfiles
* Complete new set from Rob/Anders
*
*
C
C     Code created by 
C
C     Robert Kutschke : kutschke@lns598.lns.cornell.edu
C     Anders Ryd      : ryd@charm.physics.ucsb.edu
C
C     Created : Sept 1994 -- June 1995
C     Title   : cyl_int
C     Purpose : find intercept of track and cylinder
C     
C
C     Modifications:
C
C
C



      subroutine cyl_int(k,d0,phi,z,t,r,x,y)

      implicit none

#include "klmn/klmnseq/klmn_par.inc"

      real k,d0,phi,z,t,r,x,y
      real q,rho,u0,v0,x0,y0,x0t,y0t
      real dpsi,sang,psi1,psi2

C     Some other quantities derived from the track parameters.

      q    =  sign(1.0,k)
      rho  =  abs( 0.5/k )


      U0     =  cos(phi)
      V0     =  sin(phi)
      X0     = -d0 * v0
      Y0     =  d0 * u0

      x0t  = x0-q*rho*v0
      y0t  = y0+q*rho*u0

      dpsi=atan2(-y0t,x0t)

      sang=(r**2-x0t**2-y0t**2-rho**2)/
     +                 (2*q*rho*sqrt(x0t**2+y0t**2))
      sang = amax1(amin1(sang,1.0),-1.0)


      psi1=(asin(sang)-phi-dpsi)
      psi2=(klmn_pi-asin(sang)-phi-dpsi)


      if (psi1.gt.klmn_twopi) psi1=psi1-klmn_twopi
      if (psi1.lt.0.0) psi1=psi1+klmn_twopi
      if (psi1.lt.0.0) psi1=psi1+klmn_twopi

      if (psi2.gt.klmn_twopi) psi2=psi2-klmn_twopi
      if (psi2.lt.0.0) psi2=psi2+klmn_twopi
      if (psi2.lt.0.0) psi2=psi2+klmn_twopi


      if (psi2.lt.psi1) psi1=psi2

      x=x0t+q*rho*sin(phi+q*psi1)
      y=y0t-q*rho*cos(phi+q*psi1)


      return
      end








