*
* $Id: dedx_line.F,v 1.3 1996/04/08 14:43:26 zfiles Exp $
*
* $Log: dedx_line.F,v $
* Revision 1.3  1996/04/08 14:43:26  zfiles
* Fix bug in outward swim (had forgotten to include klmnctrl_in in
*   computation of updated energy)
*
* Revision 1.2  1995/08/29  13:28:31  zfiles
* Complete new set from Rob/Anders
*
*
C
C     Code created by 
C
C     Robert Kutschke : kutschke@lns598.lns.cornell.edu
C     Anders Ryd      : ryd@charm.physics.ucsb.edu
C
C     Created : Sept 1994 -- June 1995
C     Title   : dedx_line
C     Purpose : Calculates the energy loss and M.S along
C               a straight line segment
C     
C
C     Modifications:
C
C
C



      subroutine dedx_line(imater,p,e,delta_e,dphi2)

      implicit none

#include "klmn/klmnseq/mater_n.inc"
#include "klmn/klmnseq/mater_prop.inc"
#include "klmn/klmnseq/chamber_n.inc"
#include "klmn/klmnseq/wafer_n.inc"
#include "klmn/klmnseq/vol.inc"
#include "klmn/klmnseq/klmnctrl.inc"

      integer imater,i,n_mater

      real p,delta_e,beta,dphi2,e
      real theta2,de,l,e_kin

      beta=p/e


      delta_e=0.0
      theta2=0.0     
      e_kin=e-klmnctrl_mass

C     Loop over materials in list and calculate energy loss
C     and multiple scattering

      do 15,i=1,nmed_in_list(imater)
        n_mater=med_list(i,imater)
        l=100.0*l_list_med(i,imater)
        delta_e=delta_e+
     +       de(e_kin+float(klmnctrl_in)*delta_e,n_mater,l,beta)
        theta2=theta2+l*mater_prop_chc(n_mater)**2
 15   continue
      dphi2=theta2*(2.557/(p*beta))**2


      return

      end





