*
* $Id: del_hit.F,v 1.5 1996/06/27 05:36:22 clib Exp $
*
* $Log: del_hit.F,v $
* Revision 1.5  1996/06/27 05:36:22  clib
* Bug fix in maximum curvature cut.
*
* Revision 1.4  1996/04/08 14:44:40  zfiles
* Do not do hit deletion if track has stopped (detected by large curvature
*   at outermost point)
*
* Revision 1.3  1995/08/29  17:35:11  zfiles
* Compatibility with AIX
*
* Revision 1.2  1995/08/29  13:28:32  zfiles
* Complete new set from Rob/Anders
*
*
C
C     Code created by 
C
C     Robert Kutschke : kutschke@lns598.lns.cornell.edu
C     Anders Ryd      : ryd@charm.physics.ucsb.edu
C
C     Created : Sept 1994 -- June 1995
C     Title   : del_hit
C     Purpose : After a fit search through the hit residuls and
C               possibly delete hits.
C     
C
C     Modifications:
C
C
C
      logical function del_hit(n_call)

      implicit none

      integer n_call

      integer i,i_max
      real    sigma_max,sigma_i

      logical del_rphi,del_rz

#include "klmn/klmnseq/klmnctrl.inc"
#include "klmn/klmnseq/mater_n.inc"
#include "klmn/klmnseq/klmntrk.inc"
#include "klmn/klmnseq/cleofitcom.inc"
#include "klmn/klmnseq/klmncm.inc"
#include "klmn/klmnseq/klmnhitdel.inc"
#include "klmn/klmnseq/klmnerror.inc"


      if (abs(eta_out(1)).gt.10.0) then
        del_hit=.false.
        goto 999
      endif

      if (klmnhitdel_maxdel.eq.0) then
        del_hit=.false.
        goto 999
      endif

      if (klmnhitdel_rphidel+klmnhitdel_rzdel.ge.
     +              klmnhitdel_maxdel) then
        del_hit=.false.
        goto 999
      endif

      sigma_max=0.0

      del_rphi=klmnhitdel_nrphi-klmnhitdel_rphidel.gt.
     +                     klmnhitdel_minrphi

      del_rz=klmnhitdel_nrz-klmnhitdel_rzdel.gt.
     +                     klmnhitdel_minrz

      if ((.not.del_rphi).and.(.not.del_rz)) then
        del_hit=.false.
        goto 999
      endif



      do 10,i=1,nhits
        if ((del_rphi.and.itype(i).eq.1).or.
     +      (del_rz.and.(itype(i).eq.2.or.itype(i).eq.3))) then
          if (klmnctrl_reshit) then
          sigma_i=abs(res_s(i)/sqrt(abs(sigma(3,i)**2-sigma2_s(i))))
          else
          sigma_i=abs(res_s(i)/sqrt(abs(sigma(3,i)**2+sigma2_s(i))))
          endif
          if (sigma_max.lt.sigma_i) then
            sigma_max=sigma_i
            i_max=i
          endif
        endif
10    continue


      if (sigma_max.gt.3.5) then

         if (itype(i_max).eq.1) 
     +       klmnhitdel_rphidel=klmnhitdel_rphidel+1
         if (itype(i_max).eq.2.or.itype(i_max).eq.3.or.
     +       itype(i_max).eq.5) 
     +       klmnhitdel_rzdel=klmnhitdel_rzdel+1
           itype(i_max)=0
           n_meas=n_meas-1
           del_hit=.true.
           goto 999
      endif

      del_hit=.false.

999   return
 
      end

