*
* $Id: get_vol_num.F,v 1.5 1996/03/12 14:19:53 zfiles Exp $
*
* $Log: get_vol_num.F,v $
* Revision 1.5  1996/03/12 14:19:53  zfiles
* Updates from Anders Ryd
*
* Revision 1.4  1996/03/03 00:27:23  zfiles
* Removed warning messages. Add comments.
*
* Revision 1.3  1995/08/29 17:35:13  zfiles
* Compatibility with AIX
*
* Revision 1.2  1995/08/29  13:28:35  zfiles
* Complete new set from Rob/Anders
*
*
C
C     Code created by 
C
C     Robert Kutschke : kutschke@lns598.lns.cornell.edu
C     Anders Ryd      : ryd@charm.physics.ucsb.edu
C
C     Created : Sept 1994 -- June 1995
C     Title   : get_vol_num
C     Purpose : Finds the volume that the point x is in
C     
C
C     Modifications:
C        March  11-96 Ryd:
C                     Set error condition and return it the track starts
C                     outside the mother volume.
C
C
      integer function get_vol_num(x)

      implicit none

#include "klmn/klmnseq/chamber_n.inc"
#include "klmn/klmnseq/wafer_n.inc"
#include "klmn/klmnseq/vol.inc"
#include "klmn/klmnseq/mater_n.inc"
#include "klmn/klmnseq/table.inc"
#include "klmn/klmnseq/klmnerror.inc"

      real x(3)
      real s_list(10)

      integer waf_num_list(10),nentry,n_entered
      integer in_out_list(10)


      logical in_cham_vol
      real x_zero(3)
      integer i    

      x_zero(1)=0.0
      x_zero(2)=0.0
      x_zero(3)=0.0
 

      if (.not.in_cham_vol(1,x)) then

         call vfill(klmnerror_error,5,.true.)
         call vfill(klmnerror_nr,5,2)
         get_vol_num=0
         goto 999
        
       endif

C      start searching in the mother volume
       get_vol_num=1


 5     do 10,i=daugther_cham(get_vol_num),
     +   daugther_cham(get_vol_num)+
     +   n_daugther_cham(get_vol_num)-1

         if (in_cham_vol(i,x)) then
            get_vol_num=i
            goto 5
         endif
      
    
 10    continue

       if (get_vol_num.ne.cham_svx_n) goto 999

C     Now search the SVX volumes

      do 4,i=1,nwaf

        n_entered=0

        call waf_int(i,x,x_zero,s_list,in_out_list,
     +         n_entered)

         if (n_entered.gt.0) then 
          if (in_out_list(1).eq.-1) then
             get_vol_num=i
             goto 13
          endif
         endif 

 4    continue


 7    continue

      goto 999

 13   continue

C     Now search subvolumes

      do 20,i=daugther_waf(get_vol_num),
     +   daugther_waf(get_vol_num)+
     +   n_daugther_waf(get_vol_num)-1

        n_entered=0

        call waf_int(i-10000,x,x_zero,s_list,in_out_list,
     +         n_entered)

         if (n_entered.gt.0) then 
         if (in_out_list(1).eq.-1) then
            get_vol_num=i-10000
            goto 13
         endif
         endif
    
 20   continue

      get_vol_num=get_vol_num+10000

999   continue 

      return

      end




