*
* $Id: in_cham_vol.F,v 1.3 1995/08/29 17:35:14 zfiles Exp $
*
* $Log: in_cham_vol.F,v $
* Revision 1.3  1995/08/29 17:35:14  zfiles
* Compatibility with AIX
*
* Revision 1.2  1995/08/29  13:28:36  zfiles
* Complete new set from Rob/Anders
*
*
C
C     Code created by 
C
C     Robert Kutschke : kutschke@lns598.lns.cornell.edu
C     Anders Ryd      : ryd@charm.physics.ucsb.edu
C
C     Created : Sept 1994 -- June 1995
C     Title   : in_cham_vol
C     Purpose : check if x is in icham
C     
C
C     Modifications:
C
C
C
      logical function in_cham_vol(icham,x)

      implicit none

#include "klmn/klmnseq/chamber_n.inc"
#include "klmn/klmnseq/vol.inc"

      logical in_pcon

      integer i,icham

      real x(3)

      real xl(3),rsq

      call transform_to_local_cham(icham,x,xl) 

      i=vol_num_cham(icham)

      if (vol_is(i).eq.is_box) then
         in_cham_vol=(abs(xl(1)).lt.par_vol(i,1).and.
     +                 abs(xl(2)).lt.par_vol(i,2).and.
     +                abs(xl(3)).lt.par_vol(i,3))
      elseif (vol_is(i).eq.is_tube) then
CRYD     this is not general   
         rsq=xl(1)**2+xl(2)**2
         in_cham_vol=(rsq.gt.par_vol(i,1)**2).and.
     +               (rsq.lt.par_vol(i,2)**2)
      elseif (vol_is(i).eq.is_pcon) then
         in_cham_vol=in_pcon(i,xl)
      else
         print *,'wrong volume type in in_cham_vol'
      endif

      return

      end      




