*
* $Id: in_waf_test.F,v 1.3 1995/08/29 17:35:18 zfiles Exp $
*
* $Log: in_waf_test.F,v $
* Revision 1.3  1995/08/29 17:35:18  zfiles
* Compatibility with AIX
*
* Revision 1.2  1995/08/29  13:28:40  zfiles
* Complete new set from Rob/Anders
*
*
C
C     Code created by 
C
C     Robert Kutschke : kutschke@lns598.lns.cornell.edu
C     Anders Ryd      : ryd@charm.physics.ucsb.edu
C
C     Created : Sept 1994 -- June 1995
C     Title   : in_waf_test
C     Purpose : Check if line segment with the extreme values
C               in the argument can intercept wafer iwaf.
C     
C
C     Modifications:
C
C
C
      logical function in_waf_test(iwaf,rmin,rmax,phi_min,phi_max,
     +                 zmin,zmax)

      implicit none

#include "klmn/klmnseq/wafer_n.inc"
#include "klmn/klmnseq/klmn_par.inc"

      integer iwaf

      real rmin,rmax,phi_min,phi_max,zmin,zmax
      
      real waf_max,max_phi,min_phi



      if (rmin.gt.rmax_waf(iwaf)) then
         in_waf_test=.false.
         goto 999
      endif

      if (rmax.lt.rmin_waf(iwaf)) then
         in_waf_test=.false.
         goto 999
      endif

      if (zmin.gt.zmax_waf(iwaf)) then
         in_waf_test=.false.
         goto 999
      endif

      if (zmax.lt.zmin_waf(iwaf)) then
         in_waf_test=.false.
         goto 999
      endif

      waf_max=phimax_waf(iwaf)-phimin_waf(iwaf)
      max_phi=phi_max-phimin_waf(iwaf)
      min_phi=phi_min-phimin_waf(iwaf)

      if (min_phi.lt.0.0) then
         min_phi=min_phi+klmn_twopi
         max_phi=max_phi+klmn_twopi
      endif

      if (min_phi.gt.klmn_twopi) then
         min_phi=min_phi-klmn_twopi
         max_phi=max_phi-klmn_twopi
      endif

      if (min_phi.lt.0.0.or.min_phi.gt.klmn_twopi) then
         print *,'In_waf_test:',min_phi
      endif

      if (min_phi.gt.waf_max.and.
     +           max_phi.lt.klmn_twopi) then
         in_waf_test=.false.
         goto 999
      endif



      in_waf_test=.true.

999   continue

      if (.not.in_waf_test) then
        if (phimax_waf(iwaf)-phimin_waf(iwaf).gt.6.27) then

          print *,'Problem in_waf_test!'

          print *,phimin_waf(iwaf),phimax_waf(iwaf)
          print *,phi_min,phi_max

        endif
      endif 

      return

      end





