*
* $Id: klmn_add_hit.F,v 1.2 1995/08/29 13:28:42 zfiles Exp $
*
* $Log: klmn_add_hit.F,v $
* Revision 1.2  1995/08/29 13:28:42  zfiles
* Complete new set from Rob/Anders
*
*
C
C     Code created by 
C
C     Robert Kutschke : kutschke@lns598.lns.cornell.edu
C     Anders Ryd      : ryd@charm.physics.ucsb.edu
C
C     Created : Sept 1994 -- June 1995
C     Title   : klmn_add_hit
C     Purpose : To add a hit to the trackfit
C     
C
C     Modifications:
C
C
C


      subroutine klmn_add_hit(i,eta0,deta,vetastar,
     +                                   detaopt,veta)

      implicit none

      integer i
      real eta0(5),deta(5),detaopt(5)
      real*8 vetastar(5,5),veta(5,5)

#include "klmn/klmnseq/cleofitcom.inc"
#include "klmn/klmnseq/klmncm.inc"
#include "klmn/klmnseq/klmntrk.inc"
#include "klmn/klmnseq/klmnctrl.inc"

      real der(5),dpmin,dpmin0,pull
      real*8 weight(5,5),derd(5)
      real*8 sigma2trackdinv,dvd(5),delta_eta(5)
  
      if (itype(i).eq.1) then
c        Axial hit
         call cleoaxialder(eta0(1),eta0(3),eta0(2),
     +          eta0(5),eta0(4),i,der,dpmin0)
          dpmin=dpmin0+der(1)*deta(1)+der(2)*deta(2)+
     +      der(3)*deta(3)+der(4)*deta(4)+der(5)*deta(5)
      elseif (itype(i).eq.2) then
c       stereo hit
        call cleostereoder(eta0(1),eta0(3),eta0(2),
     +          eta0(5),eta0(4),i,der,dpmin0)
          dpmin=dpmin0+der(1)*deta(1)+der(2)*deta(2)+
     +      der(3)*deta(3)+der(4)*deta(4)+der(5)*deta(5)
      elseif (itype(i).eq.3) then
        dpmin0=eta0(5)
c       cat hit
        call cleocatder(eta0(1),eta0(3),eta0(2),
     +          eta0(5),eta0(4),i,der)
         dpmin=dpmin0+der(1)*deta(1)+der(2)*deta(2)+
     +      der(3)*deta(3)+der(4)*deta(4)+der(5)*deta(5)
      elseif (itype(i).eq.5) then
c       charge division  hit
        dpmin0=eta0(5)
        call cleochgdivder(eta0(1),eta0(3),eta0(2),
     +          eta0(5),eta0(4),i,der)
        dpmin=dpmin0+der(1)*deta(1)+der(2)*deta(2)+
     +      der(3)*deta(3)+der(4)*deta(4)+der(5)*deta(5)
      elseif (itype(i).eq.0) then
c         Hit type zero 
         call ucopy(vetastar,veta,2*25)
         call ucopy(deta,detaopt,5)
         goto 999
      elseif (itype(i).eq.4) then
       call cleosvxder(eta0(1),eta0(3),eta0(2),eta0(5),eta0(4),
     +        w_org(1,i),u_hat(1,i),v_hat(1,i),
     +        der,dpmin0)
       dpmin=dpmin0+der(1)*deta(1)+der(2)*deta(2)+
     +      der(3)*deta(3)+der(4)*deta(4)+der(5)*deta(5)
      else
         print *,'unknown hit type in klmn_add_hit:',itype(i)
      endif


      derd(1)=der(1)
      derd(2)=der(2)
      derd(3)=der(3)
      derd(4)=der(4)
      derd(5)=der(5)



       dvd(1)=vetastar(1,1)*derd(1)+vetastar(1,2)*derd(2)+
     +        vetastar(1,3)*derd(3)+vetastar(1,4)*derd(4)+
     +        vetastar(1,5)*derd(5)

       dvd(2)=vetastar(2,1)*derd(1)+vetastar(2,2)*derd(2)+
     +        vetastar(2,3)*derd(3)+vetastar(2,4)*derd(4)+
     +        vetastar(2,5)*derd(5)

       dvd(3)=vetastar(3,1)*derd(1)+vetastar(3,2)*derd(2)+
     +        vetastar(3,3)*derd(3)+vetastar(3,4)*derd(4)+
     +        vetastar(3,5)*derd(5)

       dvd(4)=vetastar(4,1)*derd(1)+vetastar(4,2)*derd(2)+
     +        vetastar(4,3)*derd(3)+vetastar(4,4)*derd(4)+
     +        vetastar(4,5)*derd(5)

       dvd(5)=vetastar(5,1)*derd(1)+vetastar(5,2)*derd(2)+
     +        vetastar(5,3)*derd(3)+vetastar(5,4)*derd(4)+
     +        vetastar(5,5)*derd(5)


      sigma2trackdinv=1.0D0/(dvd(1)*derd(1)+dvd(2)*derd(2)+
     +            dvd(3)*derd(3)+
     + dvd(4)*derd(4)+dvd(5)*derd(5)+sigma(klmnctrl_part,i)**2)



       veta(1,1)=vetastar(1,1)-dvd(1)*dvd(1)*sigma2trackdinv
       veta(1,2)=vetastar(1,2)-dvd(1)*dvd(2)*sigma2trackdinv
       veta(1,3)=vetastar(1,3)-dvd(1)*dvd(3)*sigma2trackdinv
       veta(1,4)=vetastar(1,4)-dvd(1)*dvd(4)*sigma2trackdinv
       veta(1,5)=vetastar(1,5)-dvd(1)*dvd(5)*sigma2trackdinv

       veta(2,1)=veta(1,2)
       veta(2,2)=vetastar(2,2)-dvd(2)*dvd(2)*sigma2trackdinv
       veta(2,3)=vetastar(2,3)-dvd(2)*dvd(3)*sigma2trackdinv
       veta(2,4)=vetastar(2,4)-dvd(2)*dvd(4)*sigma2trackdinv
       veta(2,5)=vetastar(2,5)-dvd(2)*dvd(5)*sigma2trackdinv

       veta(3,1)=veta(1,3)
       veta(3,2)=veta(2,3)
       veta(3,3)=vetastar(3,3)-dvd(3)*dvd(3)*sigma2trackdinv
       veta(3,4)=vetastar(3,4)-dvd(3)*dvd(4)*sigma2trackdinv
       veta(3,5)=vetastar(3,5)-dvd(3)*dvd(5)*sigma2trackdinv

       veta(4,1)=veta(1,4)
       veta(4,2)=veta(2,4)
       veta(4,3)=veta(3,4)
       veta(4,4)=vetastar(4,4)-dvd(4)*dvd(4)*sigma2trackdinv
       veta(4,5)=vetastar(4,5)-dvd(4)*dvd(5)*sigma2trackdinv

       veta(5,1)=veta(1,5)
       veta(5,2)=veta(2,5)
       veta(5,3)=veta(3,5)
       veta(5,4)=veta(4,5)
       veta(5,5)=vetastar(5,5)-dvd(5)*dvd(5)*sigma2trackdinv


      
       pull=(dpmin-d(klmnctrl_part,i))/
     +         sigma(klmnctrl_part,i)**2
      
 

        delta_eta(1)=pull*(veta(1,1)*der(1)+veta(1,2)*der(2)+
     +                     veta(1,3)*der(3)+veta(1,4)*der(4)+
     +                     veta(1,5)*der(5))

        detaopt(1)=deta(1)-delta_eta(1)

        delta_eta(2)=pull*(veta(2,1)*der(1)+veta(2,2)*der(2)+
     +                     veta(2,3)*der(3)+veta(2,4)*der(4)+
     +                     veta(2,5)*der(5))

        detaopt(2)=deta(2)-delta_eta(2)

        delta_eta(3)=pull*(veta(3,1)*der(1)+veta(3,2)*der(2)+
     +                     veta(3,3)*der(3)+veta(3,4)*der(4)+
     +                     veta(3,5)*der(5))

        detaopt(3)=deta(3)-delta_eta(3)

        delta_eta(4)=pull*(veta(4,1)*der(1)+veta(4,2)*der(2)+
     +                     veta(4,3)*der(3)+veta(4,4)*der(4)+
     +                     veta(4,5)*der(5))

        detaopt(4)=deta(4)-delta_eta(4)

        delta_eta(5)=pull*(veta(5,1)*der(1)+veta(5,2)*der(2)+
     +                     veta(5,3)*der(3)+veta(5,4)*der(4)+
     +                     veta(5,5)*der(5))

        detaopt(5)=deta(5)-delta_eta(5)



      if (klmnctrl_chisq) then

        call invert_sym_d(vetastar,weight)

        dpmin=dpmin0+der(1)*detaopt(1)+der(2)*detaopt(2)+
     +    der(3)*detaopt(3)+der(4)*detaopt(4)+der(5)*detaopt(5)


        chisq=chisq+delta_eta(1)**2*weight(1,1)+
     +      delta_eta(2)**2*weight(2,2)+delta_eta(3)**2*weight(3,3)+
     +      delta_eta(4)**2*weight(4,4)+delta_eta(5)**2*weight(5,5)+
     +      2.0*(delta_eta(1)*(delta_eta(2)*weight(1,2)+
     +      delta_eta(3)*weight(1,3)+delta_eta(4)*weight(1,4)+
     +      delta_eta(5)*weight(1,5))+delta_eta(2)*(
     +      delta_eta(3)*weight(2,3)+delta_eta(4)*weight(2,4)+
     +      delta_eta(5)*weight(2,5))+delta_eta(3)*(
     +      delta_eta(4)*weight(3,4)+delta_eta(5)*weight(3,5))+
     +      delta_eta(4)*delta_eta(5)*weight(4,5))+
     +      ((dpmin-d(klmnctrl_part,i))/sigma(klmnctrl_part,i))**2

      endif 

999   continue

      return

      end









