*
* $Id: klmn_get_geom.F,v 1.8 1996/04/29 16:04:44 zfiles Exp $
*
* $Log: klmn_get_geom.F,v $
* Revision 1.8  1996/04/29 16:04:44  zfiles
* Allow comment headers at the start of the files.
* Test on lout1 and lout2 to enable output.
* Add error return.
*
* Revision 1.7  1996/04/23 23:58:38  zfiles
* Comments in previous version are wrong!
* True comment:
*      Move file opening and closing and accompanying messages to
*           a new routine, KLMNBR.
*
* Revision 1.6  1996/04/23 06:56:42  zfiles
* More mods from Rob.
*
* Revision 1.5  1995/09/05  13:15:10  zfiles
*  Remove B field initialization.
*  Add a variable to enable/disable writing of the two output files.
*
* Revision 1.4  1995/08/29  17:35:19  zfiles
* Compatibility with AIX
*
* Revision 1.3  1995/08/29  13:28:44  zfiles
* Complete new set from Rob/Anders
*
* 
C     Code created by 
C
C     Robert Kutschke : kutschke@lns598.lns.cornell.edu
C     Anders Ryd      : ryd@charm.physics.ucsb.edu
C
C     Created : Sept 1994 -- June 1995
C     Title   : klmn_get_geom
C     Purpose : To extract the relevant information from
C               the geant structures.
C     
C
C     Modifications:
C
C
C
#include "sys/CLEO_machine.h"
#include "pilot.h"
C
C      OPTIONS /CHECK=BOUNDS
C
      subroutine klmn_get_geom ( lin1, lin2, lout1, lout2, lerr )


#if defined(CLEO_TYPCHK)
      IMPLICIT NONE
#endif
      SAVE

#include "geant/gcdes/gtbank.inc"
#include "geant/gcdes/gcbank.inc"
#include "geant/gcdes/gtcuts.inc"
#include "geant/gcdes/gccuts.inc"
#include "geant/gcdes/gcjloc.inc"
#include "geant/gcdes/gtkine.inc"
#include "geant/gcdes/gckine.inc"
#include "geant/gcdes/gcmate.inc"
#include "geant/gcdes/gcmulo.inc"
#include "geant/gcdes/gconsp.inc"
#include "geant/gcdes/gtphys.inc"
#include "geant/gcdes/gcphys.inc"
#include "geant/gcdes/gtstak.inc"
#include "geant/gcdes/gcstak.inc"
#include "geant/gcdes/gttmed.inc"
#include "geant/gcdes/gctmed.inc"
#include "geant/gcdes/gttrak.inc"
#include "geant/gcdes/gctrak.inc"
#include "geant/gcdes/gcunit.inc"
#include "geant/gcdes/gtnum.inc"
#include "geant/gcdes/gcnum.inc"
#include "geant/gcdes/gtvolu.inc"
#include "geant/gcdes/gcvolu.inc"
#include "geant/gcdes/gtdraw.inc"
#include "geant/gcdes/gtlink.inc"
#include "seq/clever/cldtype.inc"

#include "klmn/klmnseq/chamber_n.inc"
#include "klmn/klmnseq/wafer_n.inc"
#include "klmn/klmnseq/vol.inc"
#include "klmn/klmnseq/cleofitcom.inc"
#include "klmn/klmnseq/mater_prop.inc"
#include "klmn/klmnseq/klmn_par.inc"

C     Logical unit numbers for IO streams.
      integer lin1, lin2, lout1, lout2

      integer jloss_mu,jrang_mu,jcoef_mu
      integer jloss_e,jrang_e,jcoef_e
      integer jloss_other,istop1
      integer isvol1,ifield1

      real fieldm1,tmaxfd1,stemax1,deemax1,epsil1
      real stmin1

      integer i,j,i_s,k
      character*4 name(10)
      real xx,par(50),att(40)

      real omc,chc,mat_absl,mat_radl,mat_dens,mat_z,mat_a
      integer mat_nwbuf,icopy_s(2000)
      real mat_ubuf(1000)
      
      integer nmed,is,jvo,ier,icopy,lnam(5),ilevel,istart

      integer lnum(5),npar,natt
      character*4 cnam(5),vname

      character*20 mat_chnama,natmed_1

      logical keep_vol,keep_mater

C     Scratch space.
      character*4 line

C     Error skipping the comment fields.
      logical lerr

C     Read past the comment fields at the start of each file.
 1    read (lin1, 4000, end=9999, err=9999 ) line
      call cltou(line)
      if ( line .ne. 'CEND' ) GOTO 1
 2    read (lin2, 4000, end=9999, err=9999 ) line
      call cltou(line)
      if ( line .ne. 'CEND' ) GOTO 2
 4000 format ( a )
      lerr = .false.

C     Write empty header to output file.
      if ( lout1 .gt. 0 ) write ( lout1, * ) 'CEND'
      if ( lout2 .gt. 0 ) write ( lout2, * ) 'CEND'

      cham_svx_n     = 19
      cham_svx_level =  4

c     First read in volumes for wafers or pt.

      nwaf=0

10    read(lin1,*) ilevel

      if (ilevel.eq.0) goto 592

      if (ilevel.eq.5) then
      read(lin1,4443) cnam(1),lnum(1),
     +              cnam(2),lnum(2),
     +              cnam(3),lnum(3),
     +              cnam(4),istart,istop1,
     +              cnam(5),lnum(5)

4443  format(A4,I3,1X,A4,I3,1X,A4,I3,1X,A4,I3,I3,1X,A4,I3)
      endif

      if (ilevel.eq.4) then
      read(lin1,4444) cnam(1),lnum(1),
     +              cnam(2),lnum(2),
     +              cnam(3),lnum(3),
     +              cnam(4),istart,istop1

4444  format(A4,I3,1X,A4,I3,1X,A4,I3,1X,A4,I3,I3)
      endif

      if (ilevel.eq.3) then
      read(lin1,4445) cnam(1),lnum(1),
     +              cnam(2),lnum(2),
     +              cnam(3),istart,istop1

4445  format(A4,I3,1X,A4,I3,1X,A4,I3,I3)
      endif

      if (ilevel.eq.2) then
      read(lin1,4446) cnam(1),lnum(1),
     +              cnam(2),istart,istop1

4446  format(A4,I3,1X,A4,I3,I3)
      endif


      if (ilevel.eq.1) then
      read(lin1,4447) cnam(1),istart,istop1


4447  format(A4,I3,I3)
      endif

      call uctoh(cnam(1),lnam(1),4,4)


      call uctoh(cnam(2),lnam(2),4,4)


      call uctoh(cnam(3),lnam(3),4,4)


      call uctoh(cnam(4),lnam(4),4,4)

      call uctoh(cnam(5),lnam(5),4,4)

      do 475,icopy=istart,istop1
        if (ilevel.eq.5) then

          lnum(4)=icopy

        else

          lnum(ilevel)=icopy

        endif

        
        
c       nlevel has to be 0 fro glvolu to work!

        nlevel=0

        call glvolu(ilevel,lnam,lnum,ier)

        if (ier.ne.0) then
          write(*,*) '**************************'
          write(*,*) 'icopy,ier:',icopy,ier
        endif

        level_waf(nwaf+1)=ilevel

        nwaf=nwaf+1

        if (nwaf.gt.max_waf) then
          print *,'To large: nwaf=',nwaf
        endif

        icopy_s(nwaf)=icopy

c        write(79,*) ilevel
C        do 473,j=1,ilevel
C          write(79,*) cnam(j)
C473     continue
        do 473,j=1,ilevel
          name(j)=cnam(j)
473     continue

        name_waf(nwaf)=name(level_waf(nwaf))


c        write(79,*) grmat(1,nlevel),grmat(2,nlevel),
c     +                          grmat(3,nlevel)
c        write(79,*) grmat(4,nlevel),grmat(5,nlevel),
c     +                          grmat(6,nlevel)
c        write(79,*) grmat(7,nlevel),grmat(8,nlevel),
c     +                          grmat(9,nlevel)
c        write(79,*) gtran(1,nlevel),gtran(2,nlevel),
c     +                          gtran(3,nlevel)


       rot_waf(1,1,nwaf)=grmat(1,nlevel)
       rot_waf(2,1,nwaf)=grmat(2,nlevel)
       rot_waf(3,1,nwaf)=grmat(3,nlevel)

       rot_waf(1,2,nwaf)=grmat(4,nlevel)
       rot_waf(2,2,nwaf)=grmat(5,nlevel)
       rot_waf(3,2,nwaf)=grmat(6,nlevel)

       rot_waf(1,3,nwaf)=grmat(7,nlevel)
       rot_waf(2,3,nwaf)=grmat(8,nlevel)
       rot_waf(3,3,nwaf)=grmat(9,nlevel)

       x_waf(1,nwaf)=gtran(1,nlevel)
       x_waf(2,nwaf)=gtran(2,nlevel)
       x_waf(3,nwaf)=gtran(3,nlevel)

      x_waf(1,nwaf)=x_waf(1,nwaf)/100.0
      x_waf(2,nwaf)=x_waf(2,nwaf)/100.0
      x_waf(3,nwaf)=x_waf(3,nwaf)/100.0

      n_daugther_waf(nwaf)=0
      daugther_waf(nwaf)=0

c     now search backwards untill parent found!

      i=nwaf-1

 19   if (i.eq.0) then
         parent_waf(nwaf)=cham_svx_n
         goto 20
      endif


      if (name(level_waf(nwaf)-1).eq.name_waf(i).and.
     +     icopy_s(nwaf).eq.icopy_s(i)) then
         if (n_daugther_waf(i).eq.0) daugther_waf(i)=nwaf+10000
         n_daugther_waf(i)=n_daugther_waf(i)+1
         parent_waf(nwaf)=i+10000
         goto 20
      endif

      i=i-1

      goto 19

20    continue

475    continue

      goto 10


592   close(lin1)



c     print *,'Are done with wafer volumes'

c     Next read in volumes for chamber

      ncham=0


1010    read(lin2,*) ilevel

      if (ilevel.eq.0) goto 1592

      if (ilevel.eq.5) then
      read(lin2,5443) cnam(1),lnum(1),
     +              cnam(2),lnum(2),
     +              cnam(3),lnum(3),
     +              cnam(4),istart,istop1,
     +              cnam(5),lnum(5)

5443  format(A4,I3,1X,A4,I3,1X,A4,I3,1X,A4,I3,I3,1X,A4,I3)
      endif

      if (ilevel.eq.4) then
      read(lin2,5444) cnam(1),lnum(1),
     +              cnam(2),lnum(2),
     +              cnam(3),lnum(3),
     +              cnam(4),istart,istop1

5444  format(A4,I3,1X,A4,I3,1X,A4,I3,1X,A4,I3,I3)
      endif

      if (ilevel.eq.3) then
      read(lin2,5445) cnam(1),lnum(1),
     +              cnam(2),lnum(2),
     +              cnam(3),istart,istop1

5445  format(A4,I3,1X,A4,I3,1X,A4,I3,I3)
      endif

      if (ilevel.eq.2) then
      read(lin2,5446) cnam(1),lnum(1),
     +              cnam(2),istart,istop1

5446  format(A4,I3,1X,A4,I3,I3)
      endif


      if (ilevel.eq.1) then
      read(lin2,5447) cnam(1),istart,istop1
5447  format(A4,I3,I3)
      endif

      call uctoh(cnam(1),lnam(1),4,4)


      call uctoh(cnam(2),lnam(2),4,4)


      call uctoh(cnam(3),lnam(3),4,4)


      call uctoh(cnam(4),lnam(4),4,4)

      call uctoh(cnam(5),lnam(5),4,4)

      do 1475,icopy=istart,istop1
        if (ilevel.eq.5) then

          lnum(4)=icopy

        else

          lnum(ilevel)=icopy

        endif

        nlevel=0

        call glvolu(ilevel,lnam,lnum,ier)

        if (ier.ne.0) then
          write(*,*) '**************************'
          write(*,*) 'icopy,ier:',icopy,ier
        endif

        level_cham(ncham+1)=ilevel

        ncham=ncham+1

        if (ncham.gt.max_cham) then
          print *,'To large :ncham',ncham
        endif

c        write(79,*) ilevel
C        do 473,j=1,ilevel
C          write(79,*) cnam(j)
C473     continue
        do 1473,j=1,ilevel
          name(j)=cnam(j)
1473     continue

        name_cham(ncham)=name(level_cham(ncham))


c        write(79,*) grmat(1,nlevel),grmat(2,nlevel),
c     +                          grmat(3,nlevel)
c        write(79,*) grmat(4,nlevel),grmat(5,nlevel),
c     +                          grmat(6,nlevel)
c        write(79,*) grmat(7,nlevel),grmat(8,nlevel),
c     +                          grmat(9,nlevel)
c        write(79,*) gtran(1,nlevel),gtran(2,nlevel),
c     +                          gtran(3,nlevel)


       rot_cham(1,1,ncham)=grmat(1,nlevel)
       rot_cham(2,1,ncham)=grmat(2,nlevel)
       rot_cham(3,1,ncham)=grmat(3,nlevel)

       rot_cham(1,2,ncham)=grmat(4,nlevel)
       rot_cham(2,2,ncham)=grmat(5,nlevel)
       rot_cham(3,2,ncham)=grmat(6,nlevel)

       rot_cham(1,3,ncham)=grmat(7,nlevel)
       rot_cham(2,3,ncham)=grmat(8,nlevel)
       rot_cham(3,3,ncham)=grmat(9,nlevel)

       x_cham(1,ncham)=gtran(1,nlevel)
       x_cham(2,ncham)=gtran(2,nlevel)
       x_cham(3,ncham)=gtran(3,nlevel)

      x_cham(1,ncham)=x_cham(1,ncham)/100.0
      x_cham(2,ncham)=x_cham(2,ncham)/100.0
      x_cham(3,ncham)=x_cham(3,ncham)/100.0

      n_daugther_cham(ncham)=0
      daugther_cham(ncham)=0

c     now search backwards untill parent found!

      i=ncham-1

 1019   if (i.eq.0) then
         parent_cham(ncham)=0
         goto 1020
      endif


      if (name(level_cham(ncham)-1).eq.name_cham(i)) then
         if (n_daugther_cham(i).eq.0) daugther_cham(i)=ncham
         n_daugther_cham(i)=n_daugther_cham(i)+1
         parent_cham(ncham)=i
         goto 1020
      endif

      i=i-1

      goto 1019

1020    continue

1475    continue

      goto 1010


1592   close(lin2)

c      print *,'Are done with chamber volumes'


       nvol=0

       do 2030,i=1,nvolum

          jvo=lq(jvolum-i)
          if (jvo.le.0) goto 2030

          call uhtoc(iq(jvolum+i),4,vname,4)

        keep_vol=.false.


        do 2031,j=1,nwaf
           if (name_waf(j).eq.vname) then
              keep_vol=.true.
              vol_num_waf(j)=nvol+1
           endif
 2031   continue

        do 2040,j=1,ncham
           if (name_cham(j).eq.vname) then
              keep_vol=.true.
              vol_num_cham(j)=nvol+1
           endif
 2040   continue

       if (keep_vol) then
          nvol=nvol+1
          if (nvol.gt.max_vol) then
            print *,'To large : nvol:',nvol
          endif
       else
          goto 2030
       endif

       is=q(jvo+2)
       nmed=q(jvo+4)

       if (is.ne.1.and.is.ne.5.and.is.ne.12.and.
     +     is.ne.2.and.is.ne.11.and.is.ne.10) then
          print *,'Volume error!! is=',is
          stop
        endif

        call gfpara(vname,1,1,npar,natt,par,att)

        mattype(nvol)=nmed

        vol_name(nvol)=vname

c        print *,'nvol,vname,nmed:',nvol,vname,nmed

c        print *,is,nvol,vname

        vol_is(nvol)=is
        if (is.eq.is_box) vol_type(nvol)='BOX '
        if (is.eq.is_tube) vol_type(nvol)='TUBE'
        if (is.eq.is_trd1) vol_type(nvol)='TRD1'
        if (is.eq.is_para) vol_type(nvol)='PARA'
        if (is.eq.is_pgon) vol_type(nvol)='PGON'
        if (is.eq.is_pcon) vol_type(nvol)='PCON'

c        print *,nvol,vol_type(nvol)

        if (npar.gt.max_par) then
          print *,'to large: npar',npar
        endif

        npar_vol(nvol)=npar

c        print *,npar

        do 2032,j=1,npar
          if (is.eq.12.and.j.le.3) then
            par_vol(nvol,j)=par(j)
          elseif (is.eq.11.and.j.le.4) then
            par_vol(nvol,j)=par(j)
          elseif (is.eq.10.and.j.ge.4) then
            par_vol(nvol,j)=par(j)
          else
            par_vol(nvol,j)=par(j)/100.0
          endif
2032    continue
        

2030   continue

c      print *,vol_type(1),vol_type(2),vol_type(3),vol_type(4)


      do 3001,i=1,90
         elow_t(i)=elow(i)
         if ( lout2 .gt. 0 ) write(lout2,*) elow(i)
3001  continue

      num_mat=0

c      print *,'iq(jmate-2):',iq(jmate-2)

      do 3008,i=1,iq(jmate-2)

      keep_mater=.false.

      do 3009,j=1,nvol
        if (i.eq.mattype(j)) then
c           print *,i,j,mattype(j),vol_name(j)
           keep_mater=.true.
           mattype_n(j)=num_mat+1
        endif
3009  continue

      if (keep_mater) then
        num_mat=num_mat+1
        if (num_mat.gt.max_mater_prop) then
          print *,'to large: num_mat',num_mat
        endif
      else
        goto 3008
      endif

      call gftmed(i,natmed_1,nmat,isvol1,ifield1,fieldm1,
     +           tmaxfd1,stemax1,deemax1,epsil1,stmin1,
     +           mat_ubuf,mat_nwbuf)

c      print *,'+++++++++++++++++'
c      print *,natmed
c      print *,nmat
c      print *,'+++++++++++++++++'


c      print *,'Calling gfmate'

      call gfmate(nmat,mat_chnama,mat_a,mat_z,mat_dens,
     +          mat_radl,mat_absl,mat_ubuf,mat_nwbuf)

      IF (MAT_A.GT.0.0) THEN
        call gmoli(mat_a,mat_z,1.0,1,mat_dens,omc,chc)
      else
        chc=0.0
      endif

    
      mater_name(num_mat)=mat_chnama
      mater_prop_a(num_mat)=mat_a
      mater_prop_z(num_mat)=mat_z
      mater_prop_dens(num_mat)=mat_dens
      mater_prop_radl(num_mat)=mat_radl
      mater_prop_chc(num_mat)=chc

      if ( lout2 .gt. 0 ) then
         write(lout2,*) i
         write(lout2,*) mat_chnama
         write(lout2,*) mat_a,mat_z
         write(lout2,*) mat_dens,mat_radl,mat_absl
         write(lout2,*) chc
      endif


      IF (MAT_A.GT.0.0) THEN

c         print *,'jma,nmat:',jma,nmat

         jma=lq(jmate-nmat)

         jloss_mu=lq(jma-2)
         jrang_mu=lq(jma-16)
         jcoef_mu=lq(jma-18)

         jloss_e=lq(jma-1)
         jrang_e=lq(jma-15)
         jcoef_e=lq(jma-17)

         jloss_other=lq(jma-3)

         do 3015,j=1,90


           par_eloss(1,j,num_mat)=q(jloss_e+j)
           par_stopr(1,j,num_mat)=q(jrang_e+j)
           par_xcoef1(1,j,num_mat)=q(jcoef_e+3*(j-1)+1)
           par_xcoef2(1,j,num_mat)=q(jcoef_e+3*(j-1)+2)
           par_xcoef3(1,j,num_mat)=q(jcoef_e+3*(j-1)+3)

           if ( lout2 .gt. 0 )
     +     write(lout2,*)q(jloss_e+j), q(jrang_e+j),
     +      q(jcoef_e+3*(j-1)+1), q(jcoef_e+3*(j-1)+2),
     +      q(jcoef_e+3*(j-1)+3)


           par_eloss(2,j,num_mat)=q(jloss_e+j+91)
           par_stopr(2,j,num_mat)=q(jrang_e+j+91)
           par_xcoef1(2,j,num_mat)=q(jcoef_e+3*(j-1)+1+273)
           par_xcoef2(2,j,num_mat)=q(jcoef_e+3*(j-1)+2+273)
           par_xcoef3(2,j,num_mat)=q(jcoef_e+3*(j-1)+3+273)

           if ( lout2 .gt. 0 )
     +     write(lout2,*)q(jloss_e+j+91), q(jrang_e+j+91), 
     +      q(jcoef_e+3*(j-1)+1+273), q(jcoef_e+3*(j-1)+2+273),
     +      q(jcoef_e+3*(j-1)+3+273)

           par_eloss(3,j,num_mat)=q(jloss_mu+j)
           par_stopr(3,j,num_mat)=q(jrang_mu+j)
           par_xcoef1(3,j,num_mat)=q(jcoef_mu+3*(j-1)+1)
           par_xcoef2(3,j,num_mat)=q(jcoef_mu+3*(j-1)+2)
           par_xcoef3(3,j,num_mat)=q(jcoef_mu+3*(j-1)+3)

           if ( lout2 .gt. 0 )
     +     write(lout2,*) q(jloss_mu+j), q(jrang_mu+j), 
     +       q(jcoef_mu+3*(j-1)+1), q(jcoef_mu+3*(j-1)+2),
     +       q(jcoef_mu+3*(j-1)+3)

           par_eloss(4,j,num_mat)=q(jloss_other+j)
           par_stopr(4,j,num_mat)=q(jrang_mu+j+91)
           par_xcoef1(4,j,num_mat)=q(jcoef_mu+3*(j-1)+1+273)
           par_xcoef2(4,j,num_mat)=q(jcoef_mu+3*(j-1)+2+273)
           par_xcoef3(4,j,num_mat)=q(jcoef_mu+3*(j-1)+3+273)

           if ( lout2 .gt. 0 )
     +     write(lout2,*)q(jloss_other+j), q(jrang_mu+j+91),
     +      q(jcoef_mu+3*(j-1)+1+273), q(jcoef_mu+3*(j-1)+2+273),
     +      q(jcoef_mu+3*(j-1)+3+273)

           par_eloss(5,j,num_mat)=q(jloss_other+j)
           par_stopr(5,j,num_mat)=q(jrang_mu+j+91)
           par_xcoef1(5,j,num_mat)=q(jcoef_mu+3*(j-1)+1+273)
           par_xcoef2(5,j,num_mat)=q(jcoef_mu+3*(j-1)+2+273)
           par_xcoef3(5,j,num_mat)=q(jcoef_mu+3*(j-1)+3+273)

           par_eloss(6,j,num_mat)=q(jloss_other+j)
           par_stopr(6,j,num_mat)=q(jrang_mu+j+91)
           par_xcoef1(6,j,num_mat)=q(jcoef_mu+3*(j-1)+1+273)
           par_xcoef2(6,j,num_mat)=q(jcoef_mu+3*(j-1)+2+273)
           par_xcoef3(6,j,num_mat)=q(jcoef_mu+3*(j-1)+3+273)


3015       continue

      endif




3008     continue
      


       do 3044,j=1,nvol
          mattype(j)=mattype_n(j)
 3044  continue


C     now we only have to initialize the rmin,rmax tables!

      do 4010,i=1,nwaf

      if (vol_type(vol_num_waf(i)).eq.'BOX ') then

c         call get_rad_box(i,rmin_waf(i),rmax_waf(i),
c     +                   dx_vol(vol_num_waf(i)),
c     +                   dy_vol(vol_num_waf(i)),
c     +                   dz_vol(vol_num_waf(i)))

         rmin_waf(i)=0.0
         rmax_waf(i)=10000.0


      elseif (vol_type(vol_num_waf(i)).eq.'TUBE') then

         rmin_waf(i)=par_vol(vol_num_waf(i),1)

         rmax_waf(i)=par_vol(vol_num_waf(i),2)


      elseif (vol_type(vol_num_waf(i)).eq.'TRD1') then

         rmin_waf(i)=0.0

         rmax_waf(i)=10000.0

      elseif (vol_type(vol_num_waf(i)).eq.'PGON') then

         rmin_waf(i)=0.0

         rmax_waf(i)=10000.0

      elseif (vol_type(vol_num_waf(i)).eq.'PARA') then

         rmin_waf(i)=0.0

         rmax_waf(i)=10000.0

      else

         print *,'Problems in get_mater 1'

      endif

 4010 continue


c      print *,vol_type(1),vol_type(2),vol_type(3),vol_type(4)


      do 4020,i=1,ncham

      if (vol_type(vol_num_cham(i)).eq.'BOX ') then

         rmin_cham(i)=0.0

         rmax_cham(i)=100.0

      elseif (vol_type(vol_num_cham(i)).eq.'PCON') then

         rmin_cham(i)=0.0

         rmax_cham(i)=100.0

      elseif (vol_type(vol_num_cham(i)).eq.'TUBE') then

         rmin_cham(i)=par_vol(vol_num_cham(i),1)

         rmax_cham(i)=par_vol(vol_num_cham(i),2)

      else

         print *,'Problems in get_cham'
         print *,i,vol_num_cham(i),vol_type(vol_num_cham(i))

      endif


 4020 continue

c     Create the file which is used by user_trans.

      if ( lout1 .le. 0 ) return

      write (lout1,*),ncham

      do 5000,i=1,ncham

      write (lout1,*),vol_num_cham(i)
      write (lout1,*),level_cham(i)
      write (lout1,*),n_daugther_cham(i)
      write (lout1,*),daugther_cham(i)
      write (lout1,*),parent_cham(i)
      write (lout1,*),itrans_cham(i) 

      write (lout1,*),x_cham(1,i)
      write (lout1,*),x_cham(2,i)
      write (lout1,*),x_cham(3,i)

      write (lout1,*),rot_cham(1,1,i)
      write (lout1,*),rot_cham(1,2,i)
      write (lout1,*),rot_cham(1,3,i)
      write (lout1,*),rot_cham(2,1,i)
      write (lout1,*),rot_cham(2,2,i)
      write (lout1,*),rot_cham(2,3,i)
      write (lout1,*),rot_cham(3,1,i)
      write (lout1,*),rot_cham(3,2,i)
      write (lout1,*),rot_cham(3,3,i)

      write (lout1,*),rmin_cham(i)
      write (lout1,*),rmax_cham(i)
      
      write (lout1,8887),name_cham(i)
8887  format(1X,A4)

 5000 continue


      write (lout1,*),nwaf

      do 5010,i=1,nwaf

      write (lout1,*),vol_num_waf(i)
      write (lout1,*),level_waf(i)
      write (lout1,*),n_daugther_waf(i)
      write (lout1,*),daugther_waf(i)
      write (lout1,*),parent_waf(i)

      write (lout1,*),x_waf(1,i)
      write (lout1,*),x_waf(2,i)
      write (lout1,*),x_waf(3,i)

      write (lout1,*),rot_waf(1,1,i)
      write (lout1,*),rot_waf(1,2,i)
      write (lout1,*),rot_waf(1,3,i)
      write (lout1,*),rot_waf(2,1,i)
      write (lout1,*),rot_waf(2,2,i)
      write (lout1,*),rot_waf(2,3,i)
      write (lout1,*),rot_waf(3,1,i)
      write (lout1,*),rot_waf(3,2,i)
      write (lout1,*),rot_waf(3,3,i)

      write (lout1,*),rmin_waf(i)
      write (lout1,*),rmax_waf(i)
      
      write (lout1,8887),name_waf(i)

 5010 continue

      write (lout1,*),nvol

      do 5020,i=1,nvol

      write (lout1,*),mattype(i)
      write (lout1,*),mattype_n(i)
      
      write (lout1,*),npar_vol(i)
      do 5011,j=1,npar_vol(i)
        write (lout1,*),par_vol(i,j)
 5011 continue

      write (lout1,8887),vol_name(i)
      write (lout1,8887),vol_type(i)
      write (lout1,*)    vol_is(i)

 5020 continue

      do 5025,i=1,90

         write(lout1,*),elow_t(i)

5025  continue

      write (lout1,*),num_mat
      
      do 5030,i=1,num_mat

      write (lout1,*) mater_prop_a(i)
      write (lout1,*) mater_prop_z(i)
      write (lout1,*) mater_prop_dens(i)
      write (lout1,*) mater_prop_radl(i)
      write (lout1,*) mater_prop_chc(i)

      do 5035,j=1,90
        do 5036,k=1,6

           write (lout1,*) par_eloss(k,j,i)
           write (lout1,*) par_stopr(k,j,i)
           write (lout1,*) par_xcoef1(k,j,i)
           write (lout1,*) par_xcoef2(k,j,i)
           write (lout1,*) par_xcoef3(k,j,i)

5036   continue
5035  continue

      write (lout1,8886),mater_name(i)
8886  format(1X,A20)

 5030 continue

C     Normal return.
      RETURN

C     Error return.
 9999 LERR = .TRUE.

      END
