*
* $Id: klmn_init_smooth.F,v 1.3 1995/11/28 19:15:14 zfiles Exp $
*
* $Log: klmn_init_smooth.F,v $
* Revision 1.3  1995/11/28 19:15:14  zfiles
* Bug fix when last hit has ttype=1
*
* Revision 1.2  1995/08/29  13:28:46  zfiles
* Complete new set from Rob/Anders
*
*
C
C     Code created by 
C
C     Robert Kutschke : kutschke@lns598.lns.cornell.edu
C     Anders Ryd      : ryd@charm.physics.ucsb.edu
C
C     Created : Sept 1994 -- June 1995
C     Title   : klmn_init_smooth
C     Purpose : To perform initialization to do the 
C               outward fit needed for smoothing
C     
C
C     Modifications:
C
C     Oct. 17 95  Ryd:  Fixed bug in initialization of imater_n
C                       when the last hit is ttype=1
C

      subroutine klmn_init_smooth(eta0,deta,vetastar)

      implicit none

      real eta0(5),deta(5)
      real*8 vetastar(5,5)

#include "klmn/klmnseq/cleofitcom.inc"
#include "klmn/klmnseq/klmncm.inc"
#include "klmn/klmnseq/mater_n.inc"
#include "klmn/klmnseq/mater_stop.inc"
#include "klmn/klmnseq/klmnctrl.inc"


      call vzero(vetastar,2*25)
      call vzero(deta,5)
      call ucopy(eta_s(1,nhits),eta0,5)

      if (abs(eta0(1)).lt.0.03) then
         deta(1)=eta0(1)-0.03*sign(1.0,eta0(1))
         eta0(1)=0.03*sign(1.0,eta0(1))
      endif

      vetastar(1,1)=0.1D0
      vetastar(2,2)=0.01D0
      vetastar(3,3)=0.01D0
      vetastar(4,4)=1.0D0
      vetastar(5,5)=1.0D0

      klmnctrl_buildmater=.false.
      klmnctrl_chisq=.false.
      klmnctrl_in=-1

      imater_n=nmater_n-1-n_next_point(nhits)

      if (ttype(nhits).eq.1) imater_n=imater_n+1

      return

      end











