*
* $Id: klmn_xv.F,v 1.2 1995/11/28 19:19:41 zfiles Exp $
*
* $Log: klmn_xv.F,v $
* Revision 1.2  1995/11/28 19:19:41  zfiles
* Id and Log added
*
*
C     Code created by 
C
C     Anders Ryd      : ryd@charm.physics.ucsb.edu
C
C     Created : Sept 27 1995
C     Title   : klmn_xv
C     Purpose : A point on a track is specified by the inputs:
C                 a) a set of track parameters (eta) and 
C                 b) a turning angle ( psi )
C               Compute the cartesian coordinates of that point (x)
C               and a unit vector in the track direction at that
C               point (v).
C
C     Modifications:
C
C
C
C
       subroutine klmn_xv(eta,psi,x,v)

       implicit none

       real eta(5),psi,x(3),v(3)
       real q,norm

       q=eta(1)/abs(eta(1)) 

       x(1)=-eta(3)*sin(eta(2))+
     +       (sin(eta(2)+q*psi)-sin(eta(2)))/(2*eta(1))
       x(2)=eta(3)*cos(eta(2))-
     +       (cos(eta(2)+q*psi)-cos(eta(2)))/(2*eta(1))
       x(3)=eta(5)+eta(4)*psi*q/(2*eta(1))

       v(1)=cos(eta(2)+q*psi)*q/(2*eta(1))

       v(2)=sin(eta(2)+q*psi)*q/(2*eta(1))

       v(3)=eta(4)*q/(2*eta(1))

       norm=sqrt(v(1)**2+v(2)**2+v(3)**2)

       v(1)=v(1)/norm
       v(2)=v(2)/norm
       v(3)=v(3)/norm

       return
 
       end
