*
* $Id: para_intercept.F,v 1.2 1995/08/29 13:28:52 zfiles Exp $
*
* $Log: para_intercept.F,v $
* Revision 1.2  1995/08/29 13:28:52  zfiles
* Complete new set from Rob/Anders
*
*
C
C     Code created by 
C
C     Robert Kutschke : kutschke@lns598.lns.cornell.edu
C     Anders Ryd      : ryd@charm.physics.ucsb.edu
C
C     Created : Sept 1994 -- June 1995
C     Title   : para_intercept
C     Purpose : Find the intercept of a straight line with
C               a para volume
C     
C
C     Modifications:
C
C
C

      subroutine para_intercept(s_list,in_out_list,n_inter,
     +                             ivol,x,xto)


      implicit none

#include "klmn/klmnseq/vol.inc"

      integer in_out_list(10),n_inter,n_inter_plane
      real s_list(10)

      real s_list_plane(10)

      real  x(3),xto(3)

      real*8 rmin,rmax,rmin1,rmin2,rmax1,rmax2,z1,z2,z
      real*8 phi,theta

      integer npdv    

      real*8 s(4),in_out(4),vxy2,vx,q2,smin,lmin

      logical bubble
   
      integer j,i,ivol,nz

      real  v(3)
      real*8 x1(3),x2(3),x3(3),x4(3),x5(3)
      real*8 x6(3),x7(3),x8(3),dx,dy,dz

      n_inter_plane=0
    
      n_inter=0

      v(1)=xto(1)-x(1)
      v(2)=xto(2)-x(2)
      v(3)=xto(3)-x(3)
 
      

      if (par_vol(ivol,4).ne.0.0) then
         print *,'alpha is not zero! Error!'
      endif

      phi=par_vol(ivol,6)*0.017453292
      theta=par_vol(ivol,5)*0.017453292

      dx=par_vol(ivol,1)
      dy=par_vol(ivol,2)
      dz=par_vol(ivol,3)


      x1(1)=dx
      x1(2)=sin(phi)*tan(theta)*dz-dy
      x1(3)=dz

      x2(1)=dx
      x2(2)=sin(phi)*tan(theta)*dz+dy
      x2(3)=dz

      x3(1)=dx
      x3(2)=-sin(phi)*tan(theta)*dz-dy
      x3(3)=-dz

      x4(1)=dx
      x4(2)=-sin(phi)*tan(theta)*dz+dy
      x4(3)=-dz


      x5(1)=-dx
      x5(2)=sin(phi)*tan(theta)*dz-dy
      x5(3)=dz

      x6(1)=-dx
      x6(2)=sin(phi)*tan(theta)*dz+dy
      x6(3)=dz

      x7(1)=-dx
      x7(2)=-sin(phi)*tan(theta)*dz-dy
      x7(3)=-dz

      x8(1)=-dx
      x8(2)=-sin(phi)*tan(theta)*dz+dy
      x8(3)=-dz

      call in_quad(x,v,x1,x2,x3,x4,s_list_plane,n_inter_plane)
      call in_quad(x,v,x5,x6,x7,x8,s_list_plane,n_inter_plane)
      call in_quad(x,v,x1,x3,x5,x7,s_list_plane,n_inter_plane)
      call in_quad(x,v,x2,x4,x6,x8,s_list_plane,n_inter_plane)
      call in_quad(x,v,x1,x2,x5,x6,s_list_plane,n_inter_plane)
      call in_quad(x,v,x3,x4,x7,x8,s_list_plane,n_inter_plane)



      if (mod(n_inter_plane,2).ne.0) then
         print *,'in para_intercept'
         print *,'n_inter_plane:',n_inter_plane
         print *,'dx,dy,dz:',dx,dy,dz
         print *,'phi,theta:',phi,theta
         print *,'x :',x(1),x(2),x(3)
         print *,'v :',v(1),v(2),v(3)
         print *,'x1:',x1(1),x1(2),x1(3)
         print *,'x2:',x2(1),x2(2),x2(3)
         print *,'x3:',x3(1),x3(2),x3(3)
         print *,'x4:',x4(1),x4(2),x4(3)
         print *,'x5:',x5(1),x5(2),x5(3)
         print *,'x6:',x6(1),x6(2),x6(3)
         print *,'x7:',x7(1),x7(2),x7(3)
         print *,'x8:',x8(1),x8(2),x8(3)
      endif 
 
40    bubble=.false.

      do 50,i=1,n_inter_plane-1     
        if (s_list_plane(i).gt.s_list_plane(i+1)) then
          bubble=.true.
          call swapr(s_list_plane(i),s_list_plane(i+1))
        endif
50    continue

      if (bubble) goto 40

c     odd is in, even is out

      do 60,i=1,n_inter_plane
        if (s_list_plane(i).lt.1.0
     +             .and.s_list_plane(i).gt.0.0) then
          n_inter=n_inter+1
          s_list(n_inter)=s_list_plane(i)
          if (mod(i,2).eq.0) then
            in_out_list(n_inter)=-1
          else
            in_out_list(n_inter)=1
          endif 
        endif
60    continue


      return

      end









