*
* $Id: t_to_t.F,v 1.2 1995/08/29 13:29:02 zfiles Exp $
*
* $Log: t_to_t.F,v $
* Revision 1.2  1995/08/29 13:29:02  zfiles
* Complete new set from Rob/Anders
*
*
C
C     Code created by 
C
C     Robert Kutschke : kutschke@lns598.lns.cornell.edu
C     Anders Ryd      : ryd@charm.physics.ucsb.edu
C
C     Created : Sept 1994 -- June 1995
C     Title   : t_to_t
C     Purpose : transport trackparameters in vacuum
C     
C
C     Modifications:
C
C
C

      subroutine t_to_t(eta,deta,veta,etap,
     +           detap,vetap,dx,dy,dz,itrans)

      implicit none

#include "klmn/klmnseq/klmn_par.inc"

      real eta(5),etap(5),deta(5),detap(5)
      real*8 veta(5,5),vetap(5,5)
      real dx,dy,dz
       
      real*8 k,kp,phi,phip,d,dp,z,zp,t,tp

      integer itrans

      real*8 a(5,5),va(5,5)
      real*8 inv2k,q,xcp,ycp,rcp,sphi,cphi,dr,dphi
      real*8 invrcp,inv2k2
 

      k=eta(1)
      d=eta(3)
      phi=eta(2)
      z=eta(5)
      t=eta(4)   



      q=sign(1.0D0,k)

      inv2k=0.5D0/k
      inv2k2=inv2k/k

      sphi=sin(phi)
      cphi=cos(phi)

      dr=d+inv2k

      xcp=dx-dr*sphi
      ycp=dy+dr*cphi

      rcp=sqrt(xcp**2+ycp**2)
      invrcp=1.0D0/rcp

      kp=k
      dp=q*rcp-inv2k
      phip=-atan2(xcp,ycp)
      if (q.lt.0.0D0) phip=phip+klmn_dpi
      if (phip.lt.0.0D0) phip=phip+klmn_dtwopi

      dphi=phi-phip

      if (dphi.gt.klmn_dpi) dphi=dphi-klmn_dtwopi
      if (dphi.lt.-klmn_dpi) dphi=dphi+klmn_dtwopi


      if (itrans.eq.1) then
        if (k.lt.0.0D0.and.dphi.lt.0.0D0) dphi=dphi+klmn_dtwopi
        if (k.gt.0.0D0.and.dphi.gt.0.0D0) dphi=dphi-klmn_dtwopi
      endif

      if (itrans.eq.-1) then
        if (k.lt.0.0D0.and.dphi.gt.0.0D0) dphi=dphi-klmn_dtwopi
        if (k.gt.0.0D0.and.dphi.lt.0.0D0) dphi=dphi+klmn_dtwopi
      endif

      zp=z+dz-inv2k*t*dphi
      tp=t

      
      a(3,3)=q*(ycp*cphi-xcp*sphi)*invrcp

      a(3,1)=(1.0D0-a(3,3))*inv2k2

      a(3,2)=-q*dr*(ycp*sphi+xcp*cphi)*invrcp


      a(2,1)=-(ycp*sphi+xcp*cphi)*inv2k2*invrcp**2

      a(2,3)=-2.0D0*k**2*a(2,1)

      a(2,2)=dr*(ycp*cphi-xcp*sphi)*invrcp**2

      a(5,1)=t*inv2k*(dphi/k+a(2,1))

      a(5,3)=t*inv2k*a(2,3)

      a(5,2)=t*inv2k*(a(2,2)-1.0)

      a(5,4)=-inv2k*dphi

      a(1,1)=1.0D0
      a(4,4)=1.0D0
      a(5,5)=1.0D0


      etap(1)=kp
      etap(3)=dp
      etap(2)=phip
      etap(5)=zp
      etap(4)=tp


c      call mult_a_eta_to_eta(a,deta,detap)         

      detap(1)=deta(1)
      detap(3)=a(3,1)*deta(1)+a(3,3)*deta(3)+a(3,2)*deta(2)
      detap(2)=a(2,1)*deta(1)+a(2,3)*deta(3)+a(2,2)*deta(2)
      detap(5)=a(5,1)*deta(1)+a(5,3)*deta(3)+a(5,2)*deta(2)+
     +                      deta(5)+a(5,4)*deta(4)
      detap(4)=deta(4)




      va(4,1)=veta(4,1)
      va(4,3)=veta(4,1)*a(3,1)+veta(4,3)*a(3,3)+veta(4,2)*a(3,2)
      va(4,2)=veta(4,1)*a(2,1)+veta(4,3)*a(2,3)+veta(4,2)*a(2,2)
      va(4,5)=veta(4,1)*a(5,1)+veta(4,3)*a(5,3)+veta(4,2)*a(5,2)+
     +        veta(4,5)+veta(4,4)*a(5,4)
      va(4,4)=veta(4,4)

      va(5,1)=veta(5,1)
      va(5,3)=veta(5,1)*a(3,1)+veta(5,3)*a(3,3)+veta(5,2)*a(3,2)
      va(5,2)=veta(5,1)*a(2,1)+veta(5,3)*a(2,3)+veta(5,2)*a(2,2)
      va(5,5)=veta(5,1)*a(5,1)+veta(5,3)*a(5,3)+veta(5,2)*a(5,2)+
     +        veta(5,5)+veta(5,4)*a(5,4)
      va(5,4)=veta(5,4)

      va(2,1)=veta(2,1)
      va(2,3)=veta(2,1)*a(3,1)+veta(2,3)*a(3,3)+veta(2,2)*a(3,2)
      va(2,2)=veta(2,1)*a(2,1)+veta(2,3)*a(2,3)+veta(2,2)*a(2,2)
      va(2,5)=veta(2,1)*a(5,1)+veta(2,3)*a(5,3)+veta(2,2)*a(5,2)+
     +        veta(2,5)+veta(2,4)*a(5,4)
      va(2,4)=veta(2,4)

      va(3,1)=veta(3,1)
      va(3,3)=veta(3,1)*a(3,1)+veta(3,3)*a(3,3)+veta(3,2)*a(3,2)
      va(3,2)=veta(3,1)*a(2,1)+veta(3,3)*a(2,3)+veta(3,2)*a(2,2)
      va(3,5)=veta(3,1)*a(5,1)+veta(3,3)*a(5,3)+veta(3,2)*a(5,2)+
     +        veta(3,5)+veta(3,4)*a(5,4)
      va(3,4)=veta(3,4)

      va(1,1)=veta(1,1)
      va(1,3)=veta(1,1)*a(3,1)+veta(1,3)*a(3,3)+veta(1,2)*a(3,2)
      va(1,2)=veta(1,1)*a(2,1)+veta(1,3)*a(2,3)+veta(1,2)*a(2,2)
      va(1,5)=veta(1,1)*a(5,1)+veta(1,3)*a(5,3)+veta(1,2)*a(5,2)+
     +        veta(1,5)+veta(1,4)*a(5,4)
      va(1,4)=veta(1,4)




c      call mult_a_va_to_vp(a,va,vetap)

      vetap(1,1)=va(1,1)
      vetap(1,2)=va(1,2)
      vetap(1,3)=va(1,3)
      vetap(1,4)=va(1,4)
      vetap(1,5)=va(1,5)

      vetap(3,1)=vetap(1,3)
      vetap(3,3)=a(3,1)*va(1,3)+a(3,3)*va(3,3)+a(3,2)*va(2,3)
      vetap(3,2)=a(3,1)*va(1,2)+a(3,3)*va(3,2)+a(3,2)*va(2,2)
      vetap(3,5)=a(3,1)*va(1,5)+a(3,3)*va(3,5)+a(3,2)*va(2,5)
      vetap(3,4)=a(3,1)*va(1,4)+a(3,3)*va(3,4)+a(3,2)*va(2,4)

      vetap(2,1)=vetap(1,2)
      vetap(2,3)=vetap(3,2)
      vetap(2,2)=a(2,1)*va(1,2)+a(2,3)*va(3,2)+a(2,2)*va(2,2)
      vetap(2,5)=a(2,1)*va(1,5)+a(2,3)*va(3,5)+a(2,2)*va(2,5)
      vetap(2,4)=a(2,1)*va(1,4)+a(2,3)*va(3,4)+a(2,2)*va(2,4)

      vetap(5,1)=vetap(1,5)
      vetap(5,3)=vetap(3,5)
      vetap(5,2)=vetap(2,5)
      vetap(5,5)=a(5,1)*va(1,5)+a(5,3)*va(3,5)+a(5,2)*va(2,5)+
     +        va(5,5)+a(5,4)*va(4,5)
      vetap(5,4)=a(5,1)*va(1,4)+a(5,3)*va(3,4)+a(5,2)*va(2,4)+
     +        va(5,4)+a(5,4)*va(4,4)

      vetap(4,1)=vetap(1,4)
      vetap(4,3)=vetap(3,4)
      vetap(4,2)=vetap(2,4)
      vetap(4,5)=vetap(5,4)
      vetap(4,4)=va(4,4)

      return

      end










