*
* $Id: t_to_t_c.F,v 1.2 1995/08/29 13:29:02 zfiles Exp $
*
* $Log: t_to_t_c.F,v $
* Revision 1.2  1995/08/29 13:29:02  zfiles
* Complete new set from Rob/Anders
*
*
C
C     Code created by 
C
C     Robert Kutschke : kutschke@lns598.lns.cornell.edu
C     Anders Ryd      : ryd@charm.physics.ucsb.edu
C
C     Created : Sept 1994 -- June 1995
C     Title   : t_to_t_c
C     Purpose : transports trackparameters in vacuum
C     
C
C     Modifications:
C
C
C
      subroutine t_to_t_c(eta,etap,dx,dy,dz,itrans)

      implicit none

#include "klmn/klmnseq/klmn_par.inc"

      real eta(5),etap(5)
      real dx,dy,dz
      
      real k,kp,phi,phip,d,dp,z,zp,t,tp

      integer itrans

      real inv2k,q,xcp,ycp,rcp,sphi,cphi,dr,dphi


      k=eta(1)
      d=eta(3)
      phi=eta(2)
      z=eta(5)
      t=eta(4)   



      q=sign(1.0,k)

      inv2k=0.5/k

      sphi=sin(phi)
      cphi=cos(phi)

      dr=d+inv2k

      xcp=dx-dr*sphi
      ycp=dy+dr*cphi

      rcp=sqrt(xcp**2+ycp**2)

      kp=k
      dp=q*rcp-inv2k
      phip=-atan2(xcp,ycp)
      if (q.lt.0.0) phip=phip+klmn_pi
      if (phip.lt.0.0) phip=phip+klmn_twopi

      dphi=phi-phip

      if (dphi.gt.klmn_pi) dphi=dphi-klmn_twopi
      if (dphi.lt.-klmn_pi) dphi=dphi+klmn_twopi


      if (itrans.eq.1) then
        if (k.lt.0.0.and.dphi.lt.0.0) dphi=dphi+klmn_twopi
        if (k.gt.0.0.and.dphi.gt.0.0) dphi=dphi-klmn_twopi
      endif

      if (itrans.eq.-1) then
        if (k.lt.0.0.and.dphi.gt.0.0) dphi=dphi-klmn_twopi
        if (k.gt.0.0.and.dphi.lt.0.0) dphi=dphi+klmn_twopi
      endif


      zp=z+dz-inv2k*t*dphi
      tp=t



      etap(1)=kp
      etap(3)=dp
      etap(2)=phip
      etap(5)=zp
      etap(4)=tp


      return

      end










