*
* $Id: waf_dist.F,v 1.2 1995/08/29 13:29:09 zfiles Exp $
*
* $Log: waf_dist.F,v $
* Revision 1.2  1995/08/29 13:29:09  zfiles
* Complete new set from Rob/Anders
*
*
C
C     Code created by 
C
C     Robert Kutschke : kutschke@lns598.lns.cornell.edu
C     Anders Ryd      : ryd@charm.physics.ucsb.edu
C
C     Created : Sept 1994 -- June 1995
C     Title   : waf_dist
C     Purpose : Calculate the distance (in phi) between
C               iline and iwaf
C     
C
C     Modifications:
C
C
C

      subroutine waf_dist(iline,iwaf,dist)

      implicit none

#include "klmn/klmnseq/table.inc"
#include "klmn/klmnseq/wafer_n.inc"
#include "klmn/klmnseq/vol.inc"
#include "klmn/klmnseq/klmn_par.inc"

       
      real dist
      integer iwaf,iline
      real phiwaf_max,phi_l

      phiwaf_max=phimax_waf(iwaf)-phimin_waf(iwaf)
      phi_l=phi_lines(iline)-phimin_waf(iwaf)

      if (phi_l.lt.0.0) then
         phi_l=phi_l+klmn_twopi
      endif

      if (phi_l.gt.klmn_twopi) then
         phi_l=phi_l-klmn_twopi
      endif

      if ( phi_l.lt.phiwaf_max) then
         dist=0.0
         goto 999
      endif

      dist=min(phi_l-phiwaf_max,klmn_twopi-phi_l)
      
999   continue

      return

      end





