*
* $Id: waf_int.F,v 1.2 1995/08/29 13:29:10 zfiles Exp $
*
* $Log: waf_int.F,v $
* Revision 1.2  1995/08/29 13:29:10  zfiles
* Complete new set from Rob/Anders
*
*
C
C     Code created by 
C
C     Robert Kutschke : kutschke@lns598.lns.cornell.edu
C     Anders Ryd      : ryd@charm.physics.ucsb.edu
C
C     Created : Sept 1994 -- June 1995
C     Title   : waf_int
C     Purpose : This routine finds the interceptions a line from x1 to
C               x2 with the wafers.
C
C     
C
C     Modifications:
C
C
C
C


      subroutine waf_int(iwaf,x1,x2,s_list,
     +            in_out_list,n_entries)

      implicit none

#include "klmn/klmnseq/wafer_n.inc"
#include "klmn/klmnseq/vol.inc"


      integer iwaf,in_out_list(10),n_entries
      real    x1(3),x2(3),s_list(10)



      real    xl1(3),xl2(3),vl(3),s1,s2
      integer i,in_out1,in_out2

      i=vol_num_waf(iwaf)

      call transform_to_local(rot_waf(1,1,iwaf),
     +       x_waf(1,iwaf),x1,xl1) 
      call transform_to_local(rot_waf(1,1,iwaf),
     +       x_waf(1,iwaf),x2,xl2) 


      if (vol_is(i).eq.is_box) then

        call box_intercept(s_list,in_out_list,n_entries,
     +          par_vol(i,1),par_vol(i,2),par_vol(i,3),xl1,xl2)
     
      elseif (vol_is(i).eq.is_tube) then

        call tube_intercept(s_list,in_out_list,n_entries,
     +          par_vol(i,1),par_vol(i,2),par_vol(i,3),xl1,xl2)

      elseif (vol_is(i).eq.is_trd1) then

        call trd1_intercept(s_list,in_out_list,n_entries,
     +     par_vol(i,1),par_vol(i,2),
     +     par_vol(i,3),par_vol(i,4),xl1,xl2)

      elseif (vol_is(i).eq.is_pgon) then

        call pgon_intercept(s_list,in_out_list,n_entries,
     +     i,xl1,xl2)

      elseif (vol_is(i).eq.is_para) then

        call para_intercept(s_list,in_out_list,n_entries,
     +     i,xl1,xl2)

      else

        print *,'wrong volume type in waf_int'

      endif

      return

      end
     




















