*
* $Id: draw_pgon_waf.F,v 1.2 1995/09/07 23:49:13 zfiles Exp $
*
* $Log: draw_pgon_waf.F,v $
* Revision 1.2  1995/09/07 23:49:13  zfiles
* Added Id and Log
*
*
C     This routine finds the points along a line from x1 to x2 where
C     the line enters or exits a pcon with inner radius of rmin and
C     outer radius of rmax. The fractional distance at the entrance 
C     and exits points are stored in s_list and in_out_list flags if
C     the point was an entrance (+1) or an exit (-1). Cmp box_intercept.
C     n_inter gives the number of entrance+exits.


      subroutine draw_pgon_waf(i,ivol)


      implicit none

#include "klmn/klmnseq/vol.inc"

      real*8 rmin,rmax,rmin1,rmin2,rmax1,rmax2,z1,z2,z
      real*8 phi,phi1,dphi

      integer npdv    

      real*8 s(4),in_out(4),vxy2,vx,q2,smin,lmin

      logical bubble
   
      integer j,i,ivol,nz

      real x1(3),x2(3),x3(3),x4(3)


 
      
      if (abs(par_vol(ivol,4)*3+4-npar_vol(ivol)).gt.0.1) then
         print *,'In pgon_intercept'
         print *,'Paramter counting is wrong!'
      endif

      phi1=par_vol(ivol,1)*0.017453292
      dphi=par_vol(ivol,2)*0.017453292
      npdv=nint(par_vol(ivol,3))
      nz=nint(par_vol(ivol,4))
      phi=dphi/npdv

c     First do the ends.

      z=par_vol(ivol,5)
      rmin=par_vol(ivol,6)
      rmax=par_vol(ivol,7)

      if (rmin.eq.rmax) goto 6

      if (rmin.lt.0.001) then
        print *,'In pgon_intercept'
        print *,'rmin to small:',rmin
        rmin=0.001
      endif

      do 8,j=1,npdv

        x1(1)=cos((j-1)*phi+phi1)*rmin/cos(phi/2)
        x1(2)=sin((j-1)*phi+phi1)*rmin/cos(phi/2)
        x1(3)=z

        x2(1)=cos((j)*phi+phi1)*rmin/cos(phi/2)
        x2(2)=sin((j)*phi+phi1)*rmin/cos(phi/2)
        x2(3)=z

        x3(1)=cos((j-1)*phi+phi1)*rmax/cos(phi/2)
        x3(2)=sin((j-1)*phi+phi1)*rmax/cos(phi/2)
        x3(3)=z

        x4(1)=cos((j)*phi+phi1)*rmax/cos(phi/2)
        x4(2)=sin((j)*phi+phi1)*rmax/cos(phi/2)
        x4(3)=z

        call draw_quad(i,x1,x2,x3,x4)

8     continue      

6     continue 

c      print *,'Inter in ends:',n_inter_plane

c      if (n_inter_plane.ne.0) then 
c
c        print *,'x  :',x(1),x(2),x(3)
c        print *,'xto:',xto(1),xto(2),xto(3)
c        print *,'x1 :',x1(1),x1(2),x1(3)
c        print *,'x2 :',x2(1),x2(2),x2(3)
c        print *,'x3 :',x3(1),x3(2),x3(3)
c        print *,'x4 :',x4(1),x4(2),x4(3)
c        print *,'phi,dphi,npdv:',phi,dphi,npdv
c        print *,'rmin,rmax:',rmin,rmax
c      endif

      z=par_vol(ivol,(nz-1)*3+5)
      rmin=par_vol(ivol,(nz-1)*3+6)
      rmax=par_vol(ivol,(nz-1)*3+7)

      if (rmin.eq.rmax) goto 9

      if (rmin.lt.0.001) then
        print *,'In pgon_intercept'
        print *,'rmin to small:',rmin
        rmin=0.001
      endif

      do 7,j=1,npdv

        x1(1)=cos((j-1)*phi+phi1)*rmin/cos(phi/2)
        x1(2)=sin((j-1)*phi+phi1)*rmin/cos(phi/2)
        x1(3)=z

        x2(1)=cos((j)*phi+phi1)*rmin/cos(phi/2)
        x2(2)=sin((j)*phi+phi1)*rmin/cos(phi/2)
        x2(3)=z

        x3(1)=cos((j-1)*phi+phi1)*rmax/cos(phi/2)
        x3(2)=sin((j-1)*phi+phi1)*rmax/cos(phi/2)
        x3(3)=z

        x4(1)=cos((j)*phi+phi1)*rmax/cos(phi/2)
        x4(2)=sin((j)*phi+phi1)*rmax/cos(phi/2)
        x4(3)=z

        call draw_quad(i,x1,x2,x3,x4)

7     continue      




c     Now do the main areas

9     continue


      do 10,i=1,nz-1

        z1=par_vol(ivol,2+i*3)
        z2=par_vol(ivol,5+i*3)
        rmin1=par_vol(ivol,3+i*3)
        rmin2=par_vol(ivol,6+i*3)
        rmax1=par_vol(ivol,4+i*3)
        rmax2=par_vol(ivol,7+i*3)

        if (rmin1.lt.0.001) then
          print *,'In pgon_intercept'
          print *,'rmin1 to small:',rmin1
          rmin1=0.001
        endif

        if (rmin2.lt.0.001) then
          print *,'In pgon_intercept'
          print *,'rmin2 to small:',rmin2
          rmin2=0.001
        endif


        if (z1.eq.z2) then
          PRint *,'z1=z2 not implemented in pgon_intercept;'
        endif

        if (dphi.lt.359.0) then

          x1(1)=cos(phi1)*rmin1/cos(phi/2)
          x1(2)=sin(phi1)*rmin1/cos(phi/2)
          x1(3)=z1
          
          x2(1)=cos(phi1)*rmin2/cos(phi/2)
          x2(2)=sin(phi1)*rmin2/cos(phi/2)
          x2(3)=z2
          
          x3(1)=cos(phi1)*rmax1/cos(phi/2)
          x3(2)=sin(phi1)*rmax1/cos(phi/2)
          x3(3)=z1
          
          x4(1)=cos(phi1)*rmax2/cos(phi/2)
          x4(2)=sin(phi1)*rmax2/cos(phi/2)
          x4(3)=z2

          call draw_quad(i,x1,x2,x3,x4)
          
          x1(1)=cos(phi1+dphi)*rmin1/cos(phi/2)
          x1(2)=sin(phi1+dphi)*rmin1/cos(phi/2)
          x1(3)=z1
          
          x2(1)=cos(phi1+dphi)*rmin2/cos(phi/2)
          x2(2)=sin(phi1+dphi)*rmin2/cos(phi/2)
          x2(3)=z2
          
          x3(1)=cos(phi1+dphi)*rmax1/cos(phi/2)
          x3(2)=sin(phi1+dphi)*rmax1/cos(phi/2)
          x3(3)=z1
          
          x4(1)=cos(phi1+dphi)*rmax2/cos(phi/2)
          x4(2)=sin(phi1+dphi)*rmax2/cos(phi/2)
          x4(3)=z2

          call draw_quad(i,x1,x2,x3,x4)
          
        endif


      do 20,j=1,npdv


          x1(1)=cos((j-1)*phi+phi1)*rmin1/cos(phi/2)
          x1(2)=sin((j-1)*phi+phi1)*rmin1/cos(phi/2)
          x1(3)=z1

          x2(1)=cos((j)*phi+phi1)*rmin1/cos(phi/2)
          x2(2)=sin((j)*phi+phi1)*rmin1/cos(phi/2)
          x2(3)=z1

          x3(1)=cos((j-1)*phi+phi1)*rmin1/cos(phi/2)
          x3(2)=sin((j-1)*phi+phi1)*rmin1/cos(phi/2)
          x3(3)=z2

          x4(1)=cos((j)*phi+phi1)*rmin1/cos(phi/2)
          x4(2)=sin((j)*phi+phi1)*rmin1/cos(phi/2)
          x4(3)=z2

          call draw_quad(i,x1,x2,x3,x4)

          x1(1)=cos((j-1)*phi+phi1)*rmax1/cos(phi/2)
          x1(2)=sin((j-1)*phi+phi1)*rmax1/cos(phi/2)
          x1(3)=z1

          x2(1)=cos((j)*phi+phi1)*rmax1/cos(phi/2)
          x2(2)=sin((j)*phi+phi1)*rmax1/cos(phi/2)
          x2(3)=z1

          x3(1)=cos((j-1)*phi+phi1)*rmax1/cos(phi/2)
          x3(2)=sin((j-1)*phi+phi1)*rmax1/cos(phi/2)
          x3(3)=z2

          x4(1)=cos((j)*phi+phi1)*rmax1/cos(phi/2)
          x4(2)=sin((j)*phi+phi1)*rmax1/cos(phi/2)
          x4(3)=z2

          call draw_quad(i,x1,x2,x3,x4)

20    continue



10    continue



      return

      end









