*
* $Id: chamber_n.inc,v 1.2 1995/08/29 13:29:35 zfiles Exp $
*
* $Log: chamber_n.inc,v $
* Revision 1.2  1995/08/29 13:29:35  zfiles
* Complete new set from Rob/Anders. Id and Log added
*
*
C
C     Code created by 
C
C     Robert Kutschke : kutschke@lns598.lns.cornell.edu
C     Anders Ryd      : ryd@charm.physics.ucsb.edu
C
C     Created : Sept 1994 -- June 1995
C     Title   : chamber_n.inc
C     Purpose : common block that defines the volumes 
C               that are used in the fit. This is extracted      
C               from CLEOG.
C
C     Modifications:
C
C
C
c
c      ncham is the number of chambers that are in the table
c
c      vol_num_cham is the volume number in the vol.inc description
c      of the volumes. This is a number between 1 and nvol.
c
c      level_cham this is the depth in the GEANT volume tree. At level
c      1 we have /CLEO/.
c
c      n_daugther_cham is the number of daugther volumes. This is
c      build from the 'mater.dat' files that specifies which volumes
c      to use.
c
c      daugther_cham is the first daugther.
c
c      parent_cham is the parent chamber number.
c
c      itrans_cham is 0 if there is no translation and rotation of
c      the volume between the cleo world coordinates and the 
c      'canonical' coordinates used to describe the volume.
c      The variabel is used to avoid the translation if possible.
c
c      x_cham is the offset in the cleo world coordinate system of
c      the volume.
c
c      rot_cham is the rotation matrix that has to be aplied to the 
c      volume to give it the right orientation around the offset in
c      the world coordinate system
c               x_{world}=x_cham+rot_cham*x_{canonical}
c
c      name_cham is the volume name e.g. "CLEO" or "DRII"
c
c      The chambers are ordered in the structure so that all
c      volumes that has the same parent are consecutive. This 
c      means that the n_daughter_cham daughters of a volume
c      are conscutively after each other starting at daughter_cham.
c      This is very important and the 'mater.dat' file must contain
c      the volumes in this order!
c     
c      


c      maximum number of allowed volumes

       integer max_cham
       parameter(max_cham=50)


       integer ncham,vol_num_cham,level_cham,n_daugther_cham,
     +         daugther_cham,parent_cham,itrans_cham,cham_svx_n,
     +         cham_svx_level

       common /chamber_i/
     +         ncham,
     +         cham_svx_n,cham_svx_level,
     +         vol_num_cham(max_cham),
     +         level_cham(max_cham),
     +         n_daugther_cham(max_cham),
     +         daugther_cham(max_cham),
     +         parent_cham(max_cham),
     +         itrans_cham(max_cham)



       real x_cham,rot_cham,rmin_cham,rmax_cham 

       COMMON /chamber_r/
     +         x_cham(3,max_cham),rot_cham(3,3,max_cham),
     +         rmin_cham(max_cham),rmax_cham(max_cham)

       character*4 name_cham

       COMMON /chamber_c/
     +         name_cham(max_cham)
