*
* $Id: cleofitcom.inc,v 1.2 1995/08/29 13:29:36 zfiles Exp $
*
* $Log: cleofitcom.inc,v $
* Revision 1.2  1995/08/29 13:29:36  zfiles
* Complete new set from Rob/Anders. Id and Log added
*
*
C
C     Code created by 
C
C     Robert Kutschke : kutschke@lns598.lns.cornell.edu
C     Anders Ryd      : ryd@charm.physics.ucsb.edu
C
C     Created : Sept 1994 -- June 1995
C     Title   : cleofitcom.inc
C     Purpose : Common block that contains the hits that will be fitted.
C
C
C     Modifications:
C
C
C
C
C      The maximum number of hits allowed for in a fit

       integer max_point
       parameter(max_point=200)

c      nhits   number of hits+stops
c      itype   type of hit 0=no hit just stop
c                          1=axial wire
c                          2=stereo wire
c                          3=cathod
c                          4=silicon wafer
c      run_num current run num
c      n_meas  number of actual measurements=nhits-stops
c      iekbin  current energy bin (not used)
c      ttype   transport step type 0=transport to next point
c                                  1=don't transport
c              This is only used to not transport between adition
c              of silicon hits in the same wafer.

       integer nhits,itype,run_num,n_meas,ttype

       common /par_i/
     +         nhits,
     +         itype(max_point),ttype(max_point),
     +         run_num,n_meas

c      sigma   the precision of the measurement
c      d       the measured drift distance. Or z-position for cathod. Or
c              coordinate for the SVX hits.
c      cx,cy   and
c      x_0,y_0 describe the stereo wire:
c              z=s              (s is a parameter)
c              x=x_0+s*cx
c              y=y_0+s*cy
c              Also gives the axial wires!
c      w_org   vector that gives the wafers origin in the local
c              coordinate system at the current hit. I.e. 
c              relative to (x_0,y_0,0)
c      u_hat   and
c      v_hat   unit vectors in the silicon plane, u_hat is
c              along the direction of the current measuremnet.
    

       real sigma,d,cx,cy,x_0,y_0
       real w_org,u_hat,v_hat
         

       common /par_r/
     +         sigma(5,max_point),
     +         x_0(max_point),y_0(max_point),
     +         cx(max_point),cy(max_point),
     +         d(5,max_point),
     +         w_org(3,max_point),u_hat(3,max_point),
     +         v_hat(3,max_point)








