*
* $Id: klmn_par.inc,v 1.2 1995/09/05 20:47:26 zfiles Exp $
*
* $Log: klmn_par.inc,v $
* Revision 1.2  1995/09/05 20:47:26  zfiles
* Fix names for mass hypotheses. Some already used for other things.
*
*
C
C     Code created by 
C
C     Robert Kutschke : kutschke@lns598.lns.cornell.edu
C     Anders Ryd      : ryd@charm.physics.ucsb.edu
C
C     Created : Sept 1994 -- June 1995
C     Title   : klmn_par.inc
C     Purpose : Miscellaneous parameter definitions and a common to 
C               hold miscellaneous variables such as the magnetic field.
C
C     Modifications:
C     Sept. 5/95: kutschke
C                 Add names for mass hypotheses.
C
C
C
C

      real klmn_pi
      parameter (klmn_pi=3.141592654)

      real klmn_twopi
      parameter (klmn_twopi=2.0*klmn_pi)

      real*8 klmn_dpi
      parameter (klmn_dpi=3.141592653589793238)

      real*8 klmn_dtwopi
      parameter (klmn_dtwopi=2.0*klmn_dpi)

      real klmn_c
      parameter (klmn_c=0.299792458)

c     Names for hypotheses.
      integer klmn_elec
      parameter ( klmn_elec = 1 )
      integer klmn_muon
      parameter ( klmn_muon = 2 )
      integer klmn_pion
      parameter ( klmn_pion = 3 )
      integer klmn_kaon
      parameter ( klmn_kaon = 4 )
      integer klmn_prot
      parameter ( klmn_prot = 5 )

      real klmn_bfield,klmn_a


      common /klmn_par_r/
     +         klmn_bfield,klmn_a



