*
* $Id: klmnctrl.inc,v 1.2 1995/08/29 13:29:39 zfiles Exp $
*
* $Log: klmnctrl.inc,v $
* Revision 1.2  1995/08/29 13:29:39  zfiles
* Complete new set from Rob/Anders. Id and Log added
*
*
C
C     Code created by 
C
C     Robert Kutschke : kutschke@lns598.lns.cornell.edu
C     Anders Ryd      : ryd@charm.physics.ucsb.edu
C
C     Created : Sept 1994 -- June 1995
C     Title   : klmnctrl.inc
C     Purpose : Variables that control the fuction of the kalman fitter.
C     
C
C     Modifications:
C
C
C

c     Unless otherwise specified these variables CAN NOT be
c     changed during a track fit.

c     klmnctrl_in is +1 for a fit inwards. inwards means that the
c     track fit is opposite to the direction of the track. I.e. the
c     energy is increased in each transport step. Otherwise it is -1.

c     klmnctrl_buildmater if this variable is .true. the material banks
c     are build in each transport step. Otherwise the material banks
c     are assumed to be there since a previous fit.

c     klmnctrl_part contains the particle hypothesis for which the
c     the fit is done. 1 is electron or positron, 2 is muon, 
c     3 is pion, 4 is kaon and 5 is proton.

c     klmnctrl_q is the charge +1 or -1

c     klmnctrl_chisq if klmnctrl_chisq is true the chisq is calculated

c     klmnctrl_savepar if klmnctrl_savepar is true the trackparameters
c     and the error matrix is saved at each measurement point

c     klmnctrl_smooth if klmnctrl_smooth is true then the fit vill
c     be run backwards and smoothing performed.

c     klmnctrl_res if klmnctrl_res is true residuls are calculated
c     in the smoothing 

c     klmnctrl_reshit if this is set true the hits are included in
c     the calculation of a residul

c     klmnctrl_noms if true, then set multiple scattering terms
c     in the covariance matrix to zero.
c     klmnctrl_noeloss if true, then do not apply energy loss corrections
c     for materials through which the track propagates.
c     klmnctrl_nostraggle if true, then set straggling in eloss
c     terms in the covariance matrix to zero.

      logical klmnctrl_buildmater,klmnctrl_chisq,klmnctrl_savepar
      logical klmnctrl_smooth,klmnctrl_res,klmnctrl_reshit
      logical klmnctrl_noms,klmnctrl_noeloss,klmnctrl_nostraggle

      common /klmnctrl_l/ 
     +        klmnctrl_buildmater,klmnctrl_chisq,klmnctrl_savepar,
     +        klmnctrl_smooth,klmnctrl_res,klmnctrl_reshit,
     +        klmnctrl_noms,klmnctrl_noeloss,klmnctrl_nostraggle


      integer klmnctrl_in,klmnctrl_part

      common /klmnctrl_i/ 
     +        klmnctrl_in,klmnctrl_part


      real    klmnctrl_mass,klmnctrl_q
       
      common /klmnctrl_r/
     +        klmnctrl_mass,klmnctrl_q


