*
* $Id: klmnhitdel.inc,v 1.2 1995/08/29 13:29:42 zfiles Exp $
*
* $Log: klmnhitdel.inc,v $
* Revision 1.2  1995/08/29 13:29:42  zfiles
* Complete new set from Rob/Anders. Id and Log added
*
*
C
C     Code created by 
C
C     Robert Kutschke : kutschke@lns598.lns.cornell.edu
C     Anders Ryd      : ryd@charm.physics.ucsb.edu
C
C     Created : Sept 1994 -- June 1995
C     Title   : klmnhitdel.inc
C     Purpose : This common block is used to flag hit deletion by 
C               the kalman filter. 
C     
C
C     Modifications:
C
C
C
c
c
c
cc


c      klmnhitdel_nrphi and klmnhitdel_nrz are filled by the
c      caller of klmn_fit with the number of hits that provides
c      only rphi information and hist that provides z information.

c      klmnhitdel_minrphi and klmnhitdel_minrz are also filled by
c      the caller of klmn_fit with the minimum number of rphi and
c      z hits that is required for a fit.

c      klmnhitdel_maxdel is filled before the call to klmn_fit 
c      with the maximum number of hits that is allowed to be
c      deleted.

c      klmnhitdel_nrphi and klmnhitdel_nrz are filled by the number
c      of hits that was deleted in rphi and rz.

       integer klmnhitdel_nrphi,klmnhitdel_nrz
       integer klmnhitdel_minrphi,klmnhitdel_minrz
       integer klmnhitdel_maxdel

       integer klmnhitdel_rphidel,klmnhitdel_rzdel

       common /klmnhitdel_i/
     +         klmnhitdel_nrphi,
     +         klmnhitdel_nrz,
     +         klmnhitdel_minrphi,
     +         klmnhitdel_minrz,
     +         klmnhitdel_maxdel,
     +         klmnhitdel_rphidel,
     +         klmnhitdel_rzdel








