*
* $Id: klmntrk.inc,v 1.2 1995/08/29 13:29:43 zfiles Exp $
*
* $Log: klmntrk.inc,v $
* Revision 1.2  1995/08/29 13:29:43  zfiles
* Complete new set from Rob/Anders. Id and Log added
*
*
C
C     Code created by 
C
C     Robert Kutschke : kutschke@lns598.lns.cornell.edu
C     Anders Ryd      : ryd@charm.physics.ucsb.edu
C
C     Created : Sept 1994 -- June 1995
C     Title   : klmntrk.inc
C     Purpose : Common block that contains the input and
C               output information, except for hit information.
C     
C
C     Modifications:
C
C
C
C
C 
C
C      k_start,d0_start,phi_start,z_start,t_start are
C      the track parameters at x_start, y_start, z_start
C      which are used to start the fit.
C
C      v_start contains the initial error matrix, do not
C      need to be filled if fit starts from scratch, see 
C      below.
C 
C      start_type flags how to start the fit
C                =0 start from scratch : v_start is ignored,
C                                        and the track parameters
C                                        are used as seed.
C                =1 Equivalent to continuing a fit with the
C                   given track parameters and error matrix.
C
C      Fits with say fixed curvature can also be implemented
C      easily.
C
C      chisq_start and nhits_start cotains
C      the accumulated chisq and number of hits so far added on to the 
C      track. These will be initilized to 0 if start_type=0.
C
C
C      eta_in are the track parameters at x_end, y_end, z_end
C      at the end  ( innermost point!) of the fit. The second
C      index is the particle type. v_in is the corresponding 
C      error matrix.
C
C     
C      end_type flags where to report the final track parameters.
C              =0 transpor to distance of closest approach to
C                 the z-axis, given at xo_end, yo_end, zo_end.
C              =1 report error matrix at last hit.
C
C      chisq_end and nhits_end contains the final chisq and the 
C      total number of hits added on to the track.      
C

       integer start_type,end_type,nhits_start,nhits_end

       real    k_start,d0_start,phi_start,z_start,t_start
       real    v_in,eta_in,eta_out,v_out
       real    xo_start,yo_start,zo_start
       real    xo_in,yo_in,zo_in,xo_out,yo_out,zo_out,v_start
       real    chisq_start,chisq_in,chisq,desum,stepsum

       common /klmntrk_i/
     +        start_type,end_type,nhits_start,nhits_end

       common /klmntrk_r/
     +        k_start,d0_start,phi_start,z_start,t_start,
     +        xo_start,yo_start,zo_start,
     +        xo_in,yo_in,zo_in,xo_out,yo_out,zo_out,
     +        v_start(5,5),v_in(5,5,5),eta_in(5,5),eta_out(5),
     +        v_out(5,5),
     +        chisq_start,chisq_in(5),chisq,desum,stepsum
