*
* $Id: vol.inc,v 1.2 1995/08/29 13:29:51 zfiles Exp $
*
* $Log: vol.inc,v $
* Revision 1.2  1995/08/29 13:29:51  zfiles
* Complete new set from Rob/Anders. Id and Log added
*
*
C
C     Code created by 
C
C     Robert Kutschke : kutschke@lns598.lns.cornell.edu
C     Anders Ryd      : ryd@charm.physics.ucsb.edu
C
C     Created : Sept 1994 -- June 1995
C     Title   : vol.inc
C     Purpose :  This common contains the definitions of the volumes
c               I.e. it contains the tupes and sizes and the material
c               types of the elements the detector is build of.
c               This information is extracted from the GEANT structures
c               at initialization. Note that only the two volume types 
C     
C
C     Modifications:
C
C
C
c
c      nvol is the number of volumes.
c
c      mattype is the material type, i.e. a pointer to an entry 
c      in the mater_prop.inc common block.
c
c      mattype_n.inc is used in the building of this comon
c      and the mater_prop common to make mattype a number between 
c      1 and num_mater. Originaly mattype is the GEANT material
c      number. This variable should not be in this common!
c
c      dx_vol,dy_vol,dz_vol is the three paramters that describes 
c      the volume.
c      For a BOX  it is dx,dy,dz (half sides)
c      For a TUBE it is rmin,rmax,dz
c
c      vol_name is the volume name like "DRII" or "SVDM"
c

       integer max_vol
       parameter(max_vol=60)
       integer max_par
       parameter(max_par=50)
       integer is_box,is_tube,is_pcon,is_trd1
       integer is_para,is_pgon
       parameter (is_box=1)
       parameter (is_tube=5)
       parameter (is_trd1=2)
       parameter (is_para=10)
       parameter (is_pgon=11)
       parameter (is_pcon=12)

       integer nvol,mattype,mattype_n,npar_vol,vol_is

       common /vol_i/
     +         nvol,vol_is(max_vol),
     +         mattype(max_vol),
     +         mattype_n(max_vol),
     +         npar_vol(max_vol)



       real par_vol

       common /vol_r/
     +         par_vol(max_vol,max_par)

       character*4 vol_name,vol_type

       common /vol_c/
     +         vol_name(max_vol),vol_type(max_vol)       








